/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


# ifndef DVDREADER_CPP
# define DVDREADER_CPP

# include "DVDReader.h"

DVDReader::DVDReader(QComboBox *titel,QComboBox *alang,QComboBox *alang2,QComboBox *untertitel,Encodieren *enco,int startdebuglevel)
{
    // Den Anfangs debuglevel festlegen
    debuglevel=startdebuglevel;

    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Konstructor : DVDReader *"<<endl<<endl;
    }

    // Der uebergebene Zeiger der ComboBox  die die Auswahl der Titel anzeigt
    cotitel      = titel;
    coalang      = alang;
    coalang2     = alang2;
    countertitel = untertitel;
    encodieren   = enco;

    programmsprache="en";

}

void DVDReader::leseDVD (QString pfad)
{
    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Slot : leseDVD *"<<endl<<endl;
    }

    // Damit alle eventuell vorhanden Items entfernt werden
    cotitel->clear();

    //Oeffent die angegeben DVD
    dvdZeiger=DVDOpen(pfad);

    // Nur Fuer Debug Zwecke
    //ifoPrint(dvdZeiger,0);

    if(!dvdZeiger)
    {

        if(debuglevel==3)
        {
            cout<<"dvdread.cpp: Das DVD-Objekt konnte nicht erstellt werden! (DVDReader)"<<endl<<endl;
        }

        return;
    }

    // Einmal die anzahl der Titel auf der DVD holen
    ifoZeigerNull=ifoOpen(dvdZeiger,0);

    if(!ifoZeigerNull) 
    {
        // dvdZeiger wieder schliessen
        DVDClose(dvdZeiger);

        // Alle Anzeige Felder loeschen
        leeren();

        // Wenn das oeffnen fehl schlaegt, fuer mounten in GUI
        emit cantOpen();

        // Anzeigen mit Statusmeldungen fllen
        coalang     ->insertItem("* keine Daten *",0);
        coalang2    ->insertItem("* keine Daten *",0);
        countertitel->insertItem("* keine Daten *",0);
        cotitel     ->insertItem("* keine DVD-Daten *",0);

        if(debuglevel==3)
        {
            cout<<"dvdread.cpp: Die DVD konnte nicht geoeffnet werden! (DVDReader)"<<endl<<endl;
        }

        return;
    }
    else
    {
        // Die Anzahl der Titel abspeichern
        titeln=ifoZeigerNull->tt_srpt->nr_of_srpts;


        // Titel Laengen einlesen lassen
        leseTitel();
    }

    // Die Audio Daten abholen (dadurch auch gleich die Untertiteln)
    leseAudio(1);
}

void DVDReader::loeseDVD (void)
{
    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Slot : loeseDVD *"<<endl<<endl;
    }

    if(!ifoZeigerNull) 
    {
        // Denn NullIfo Zeiger wieder schliessen
        ifoClose(ifoZeigerNull);
    }

    if(!dvdZeiger) 
    {
        // dvdZeiger wieder schliessen
        DVDClose(dvdZeiger);
    }

    // DVD-Objekt loeschen erst ab dvdreadlib 9.5 vorhanden
    //DVDFinish();
}

void DVDReader::leseTitel(void)
{
    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Slot : leseTitel *"<<endl<<endl;
    }

    for(int var1=0;var1<titeln;++var1)
    {
        // ifo Zeiger erstellen aus der geoffneten DVD
        ifoZeiger=ifoOpen(dvdZeiger,ifoZeigerNull->tt_srpt->title[var1].title_set_nr);

        // In Wechen Abschnitt pro Titel der Film liegt 
        pgcit_Zaehler=ifoZeigerNull->tt_srpt->title[var1].vts_ttn;

        // Zeitzeiger mit den richtigen Titel initaliesieren
        zeitZeiger=&ifoZeiger->vts_pgcit->pgci_srp[pgcit_Zaehler-1].pgc->playback_time;

            if(!zeitZeiger) 
            {
                cout<<endl<<"Error!4 Die DVD konnte nicht geoeffnet werden!"<<endl;
                return;

            }
            else
            {
                // Den Anfang der Zeile zusammen basteln
                zeit=" Track ";
                temp.setNum(var1+1);

                // kontrolle ob diese Zeile noch eine Nummer hat
                if(1==temp.length())
                    temp.insert(0,"0");

                zeit+=temp+ " = ";

                // Stunden Wert3e der herausholen
                temp.setNum(zeitZeiger->hour,16);

                if(1==temp.length())
                    temp.insert(0,"0");


                // Stunden Abspeichern
                zeit+=temp+":";

                // Minuten herausholen
                temp.setNum(zeitZeiger->minute,16);
                if(1==temp.length())
                    temp.insert(0,"0");

                // Minuten abspeichern
                zeit+=temp+":";

                // Sekunden herausholen
                temp.setNum(zeitZeiger->second,16);
                if(1==temp.length())
                temp.insert(0,"0");

                // Sekunden abspeichern
                zeit+=temp;

                // Sendet die Laenge des dazugehoerigen Titels
                cotitel->insertItem(zeit);
            }

        // ifoZeiger wieder schliessen
        ifoClose(ifoZeiger);
    }

    // Den ausgewaehlten Titel zu encodieren schicken
    encodieren->settitel(0);

}

void DVDReader::leseAudio (int titel)
{
    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Slot : leseAudio *"<<endl<<endl;
    }

    // Damit alle eventuell vorhanden Items entfernt werden
    coalang      -> clear();
    coalang2     -> clear();


    if(!dvdZeiger)
    {
        cout<<endl<<"Error!5 Die DVD konnte nicht geoeffnet werden!"<<endl;
        return;
    }

    // ifo Zeiger erstellen aus der geoffneten DVD
    ifoZeiger=ifoOpen(dvdZeiger,ifoZeigerNull->tt_srpt->title[titel-1].title_set_nr);

    if(!ifoZeiger) 
    {
        cout<<endl<<"Error!6 Die DVD konnte nicht geoeffnet werden!"<<endl;
        return;
    }

    // Alle Informationen zu diesen Titel holen
    for(int zeile = 0; zeile < ifoZeiger->vtsi_mat->nr_of_vts_audio_streams; zeile++) 
    {
        //Den Audio Zeiger ein Objekt geben
        audioZeiger=&ifoZeiger->vtsi_mat->vts_audio_attr[zeile];

        // Einmal die Sprachen herausholen
        audio=leseSprache();

        // Format vorbereiten
        audio+=" : ";

        // Und das Format abholen
        audio+=leseFormat();

        // Die Audio Zielen schicken
        coalang     ->insertItem(audio);
        coalang2     ->insertItem(audio);


    }

    // Einmal den Standardwert abspeichen (wenn noch nichts gewaehlt ist)
    encodieren->setasid("");

    // Alle asid Werte abspeichern
    for(int var1 = 0; var1 < 8; var1++) 
    {
        //cout<<"Vortempsid = "<<ifoZeiger->vts_pgcit->pgci_srp->pgc->audio_control[var1]<<endl;
        if(ifoZeiger->vts_pgcit->pgci_srp->pgc->audio_control[var1] & 0x8000) 
        {
            // Denn asid-Wert ausrechen
            tempsid=ifoZeiger->vts_pgcit->pgci_srp->pgc->audio_control[var1];

            if(debuglevel>=3)
            {
                cout<<"dvdread.cpp: tempsid = "<<tempsid<<endl;
            }

            // Dadurch wird der richtige asid wert errechnet
            tempsid/=256;
            //tempsid-=1;

            // Den asid Wert abspeichern
            asid[var1].setNum(tempsid);
        }
    }

    // Nur der Optik halber
    if(debuglevel>=3)
    {
        cout<<endl;
    }

    // Kontrolle ob es schon Objekte gibt in der Combobox
    if(!((coalang->count())==0))
    {
        // Ersten Eintrag einfuegen
        coalang ->insertItem(tr("* Standard Ton *"),0);

        // Bei der zweiten Audiospur Eratztext anhaengen
        coalang2->insertItem(tr("* ohne 2 ASpur *"),0);


        // Damit der Automatisch ausgewaehlte Audiospur auch nach  Deodieren  gesendet wird
        encodieren->setaudio(coalang->currentText());
    }
    else
    {
        // Oder im Fall das es keine Sprache gibt die Standard Auswahl vortaeuschen
        encodieren->setaudio("* ");
    }

    // ifoZeiger wieder schliessen
    ifoClose(ifoZeiger);

    // Die Untertitelinfos holen
    leseUntertitel(titel);
}

void DVDReader::leseUntertitel (int titel)
{
    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Slot : leseUntertitel *"<<endl<<endl;
    }

     // Damit alle eventuell vorhanden Items entfernt werden
    countertitel -> clear();

    if(!dvdZeiger)
    {
        cout<<endl<<"Error!7 Die DVD konnte nicht geoeffnet werden!"<<endl;
        return;
    }

    // ifo Zeiger erstellen aus der geoffneten DVD
    ifoZeiger=ifoOpen(dvdZeiger,ifoZeigerNull->tt_srpt->title[titel-1].title_set_nr);

    if(!ifoZeiger) 
    {
        cout<<endl<<"Error!8 Die DVD konnte nicht geoeffnet werden!"<<endl;
        return;
    }

    // Alle Informationen zu diesen Titel holen
    for(int zeile = 0; zeile < ifoZeiger->vtsi_mat->nr_of_vts_subp_streams; zeile++) 
    {
        // Den Untertitel Zeiger auf ein Objekt legen
        unterZeiger=&ifoZeiger->vtsi_mat->vts_subp_attr[zeile];

        // Die Untertitel Informationen holen
        untertitel=leseUSprache();

        // Die Untertitel Daten schicken
        countertitel->insertItem(untertitel);
    }

    // Einmal den standard Wert abspeichen (wenn noch nichts gewaehlt ist)
    encodieren->setssid("");

    // Alle asid Werte abspeichern
    for(int var1 = 0; var1 < 32; var1++) 
    {

        if(ifoZeiger->vts_pgcit->pgci_srp->pgc->subp_control[var1] & 0x80000000) 
        {
            // Denn asid-Wert ausrechen
            tempsid=ifoZeiger->vts_pgcit->pgci_srp->pgc->subp_control[var1];

            // Dadurch wird der richtige ssid wert errechnet
            tempsid/=(256*256);
            tempsid-=32768;
 
            // Den asid Wert abspeichern
            ssid[var1].setNum(tempsid);
        }
    }

    // Kontrolle ob es schon Objekte gibt in der Combobox
    if(!((countertitel->count())==0))
    {
        // Ersten Eintrag einfuegen 
        countertitel->insertItem(tr("* Ohne Untertitel umwandeln*"),0);

    }
    else
    {
        // Wenn es keine Untertitel giebt
        countertitel->insertItem(tr("* Keine Untertitel vorhanden*"),0);

        // Oder im Fall das es keine Untertitel gibt die Standard Auswahl vortaeuschen
        encodieren->setuntertitel("* ");
    }

    // Damit der Automatisch ausgewaehlte Untertitel auch nach  Deodieren  gesendet wird
    encodieren->setuntertitel(countertitel->currentText());

    // ifoZeiger wieder schliessen
    ifoClose(ifoZeiger);
}

QString DVDReader::leseFormat (void)
{
    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Slot : leseFormat *"<<endl<<endl;
    }

    // Die Werte des AudioFormat in Text umwandeln
    switch(audioZeiger->audio_format) 
    {
      case 0:
          temp="ac3";
          break;
      case 1:
          temp="---";
          break;
      case 2:
          temp="mpeg1";
          break;
      case 3:
          temp="mpeg2ext";
          break;
      case 4:
          temp="lpcm";
          break;
      case 5:
          temp="---";
          break;
      case 6:
          temp="dts";
          break;
      default:
          temp="---";
     }

     return temp;
}

QString DVDReader::leseSprache (void)
{
    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Slot : leseSprache *"<<endl<<endl;
    }

    switch(audioZeiger->lang_type) 
    {
        case 0:
            temp="0- ";
            break;
        case 1:
             // Ersten und zweiten Buschstaben von der Sprachen einlesen
            temp=audioZeiger->lang_code>>8;
            temp+=audioZeiger->lang_code & 0xff;

            if(audioZeiger->lang_extension) {
                temp="1- ";;
            }
            break;
        default:
            temp="2- ";
    }

    // Zu dem Kuerzel auch noch den passenden Text holen
    temp+=" - "+umsetzen(temp);

    return temp;
}

QString DVDReader::leseUSprache (void)
{
    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Slot : leseUSprache *"<<endl<<endl;
    }

    if(unterZeiger->type == 1) 
    {
        if(isalpha((int)(unterZeiger->lang_code >> 8)) && isalpha((int)(unterZeiger->lang_code & 0xff)))
        {
            // Ersten und zweiten Buschstaben von der Sprachen einlesen
            temp=unterZeiger->lang_code >> 8;
            temp+=unterZeiger->lang_code & 0xff;

            // Zu dem Kuerzel auch noch den passenden Text holen
            temp+=" - "+umsetzen(temp);

            return temp;
        }
    }

        return "";
}

void DVDReader::leeren(void)
{
    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Slot : leeren *"<<endl<<endl;
    }

    // Damit alle eventuell vorhanden Items entfernt werden
    cotitel->clear();

    // Damit alle eventuell vorhanden Items entfernt werden
    coalang-> clear();

    // Damit alle eventuell vorhanden Items entfernt werden
    countertitel -> clear();
}

// Damit der richtige asid-Wert geholt wird
void DVDReader::holeasid (int titel)
{
    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Slot : holeasid *"<<endl<<endl;
    }

    if(debuglevel>=3)
    {
        cout<<"dvdread.cpp: Uebergeber Wert bei Aufruf = "<<titel<<endl;
    }

    if(!titel==0)
    {
        // Den Wert zu encodieren schicken
        encodieren->setasid(asid[titel-1]);
    }
    else
    {
        // Den Wert zu encodieren schicken
        encodieren->setasid("");
    }

    if(debuglevel>=3)
    {
        cout<<"dvdread.cpp: Rueckgabe des Aufrufs asid[titel] = "<<asid[titel-1]<<endl;
    }
}

void DVDReader::holeasid2 (int titel)
{
    if(debuglevel>=2)
    {
        cout<<"dvdread.cpp: * Slot : holeasid2 *"<<endl<<endl;
    }

    if(debuglevel>=3)
    {
        cout<<"dvdread.cpp: Uebergeber Wert bei Aufruf = "<<titel<<endl;
    }

    if(!titel==0)
    {
        // Den Wert zu encodieren schicken
        encodieren->setasid2(asid[titel-1]);
    }
    else
    {
        // Den Wert zu encodieren schicken
        encodieren->setasid2("");
    }

    if(debuglevel>=3)
    {
        cout<<"dvdread.cpp: Rueckgabe des Aufrufs asid2[titel] = "<<asid[titel-1]<<endl;
    }
}

// Damit wird der ssid wert zurueckgegeben, fuer die Untertitel auswahl
void DVDReader::holessid (int titel)
{
    // Damit die erste Zeile nicht beachtet wird
    if(!titel==0)
    {
        // Falls eine zweite Audiospur encodiert werden soll dann holed diese ab
        // ansonsten den richtigen wert fuer die Untertiteln
        if(!encodieren->get2Audiotrack())
        {
            encodieren->setssid(ssid[titel-1]);
        }
        else
        {
            encodieren->setssid(asid[titel-1]);
        }
    }
    else
    {
        // Den Wert zu encodieren schicken
        encodieren->setssid("");
    }
}

QString DVDReader::umsetzen (QString &kuerzel)
{
    if (kuerzel=="en")
        return "English";

    if (kuerzel=="de")
        return "Deutsch";

    if (kuerzel=="bg")
        return "Bulgarian";

    if (kuerzel=="cs")
        return "Czech";

    if (kuerzel=="da")
        return "Danish";

    if (kuerzel=="el")
        return "Greek";

    if (kuerzel=="eo")
        return "Esperanto";

    if (kuerzel=="es")
        return "Spanish";

    if (kuerzel=="fi")
        return "Finnish";

    if (kuerzel=="ga")
        return "Irish";

    if (kuerzel=="fr")
        return "French";

    if (kuerzel=="hr")
        return "Croatian";

    if (kuerzel=="hu")
        return "Hungarian";

    if (kuerzel=="it")
        return "Italian";

    if (kuerzel=="ja")
        return "Japanese";

    if (kuerzel=="mk")
        return "Macedonian";

    if (kuerzel=="nl")
        return "Dutch";

    if (kuerzel=="no")
        return "Norwegian";

    if (kuerzel=="pl")
        return "Polish";

    if (kuerzel=="pt")
        return "Portuguese";

    if (kuerzel=="ro")
        return "Romanian";

    if (kuerzel=="sh")
        return "Serbo-Croatian";

    if (kuerzel=="sk")
        return "Slovak";

    if (kuerzel=="sl")
        return "Slovenian";

    if (kuerzel=="sv")
        return "Swedish";

    if (kuerzel=="uk")
        return "Ukrainian";

    if (kuerzel=="tr")
        return "Turkish";

    if (kuerzel=="aa")
        return "Afar";

    if (kuerzel=="ab")
        return "Abkhazian";

    if (kuerzel=="af")
        return "Afrikaans";

    if (kuerzel=="am")
        return "Amharic";

    if (kuerzel=="ar")
        return "Arabic";

    if (kuerzel=="as")
        return "Assamese";

    if (kuerzel=="ay")
        return "Aymara";

    if (kuerzel=="az")
        return "Azerbaijani";

    if (kuerzel=="ba")
        return "Bashkir";

    if (kuerzel=="be")
        return "Byelorussian";

    if (kuerzel=="bh")
        return "Bihari";

    if (kuerzel=="bi")
        return "Bislama";

    if (kuerzel=="bn")
        return "Bengali";

    if (kuerzel=="bo")
        return "Tibetan";

    if (kuerzel=="br")
        return "Breton";

    if (kuerzel=="ca")
        return "Catalanh";

    if (kuerzel=="co")
        return "Corsican";

    if (kuerzel=="cy")
        return "Welsh";

    if (kuerzel=="dz")
        return "Bhutani";

    if (kuerzel=="et")
        return "Estonian";

    if (kuerzel=="eu")
        return "Basque";

    if (kuerzel=="fa")
        return "Persian";

    if (kuerzel=="fj")
        return "Fiji";

    if (kuerzel=="Fa")
        return "Faroese";

    if (kuerzel=="fy")
        return "Frisian";

    if (kuerzel=="gd")
        return "Scots Gaelic";

    if (kuerzel=="gl")
        return "Galician";

    if (kuerzel=="gn")
        return "Guarani";

    if (kuerzel=="gu")
        return "Gujarati";

    if (kuerzel=="ha")
        return "Hausa";

    if (kuerzel=="he")
        return "Hebrew";

    if (kuerzel=="iw")
        return "Hebrew";

    if (kuerzel=="hi")
        return "Hindi";

    if (kuerzel=="hy")
        return "Armenian";

    if (kuerzel=="ia")
        return "Interlingua";

    if (kuerzel=="id")
        return "Indonesian";

    if (kuerzel=="in")
        return "Indonesian";

    if (kuerzel=="ie")
        return "Interlingue";

    if (kuerzel=="ik")
        return "Inupiak";

    if (kuerzel=="is")
        return "Icelandic";

    if (kuerzel=="iu")
        return "Inuktitut";

    if (kuerzel=="jw")
        return "Javanese";

    if (kuerzel=="ka")
        return "Georgian";

    if (kuerzel=="kk")
        return "Kazakh";

    if (kuerzel=="kl")
        return "Greenlandic";

    if (kuerzel=="km")
        return "Cambodian";

    if (kuerzel=="kn")
        return "Kannada";

    if (kuerzel=="ko")
        return "Korean";

    if (kuerzel=="ks")
        return "Kashmiri";

    if (kuerzel=="ku")
        return "Kurdish";

    if (kuerzel=="ky")
        return "Kirghiz";

    if (kuerzel=="la")
        return "Latin";

    if (kuerzel=="ln")
        return "Lingala";

    if (kuerzel=="lo")
        return "Laothian";

    if (kuerzel=="lt")
        return "Lithuanian";

    if (kuerzel=="lv")
        return "Latvian";

    if (kuerzel=="mg")
        return "Malagasy";

    if (kuerzel=="mi")
        return "Maori";

    if (kuerzel=="ml")
        return "Malayalam";

    if (kuerzel=="mn")
        return "Mongolian";

    if (kuerzel=="mo")
        return "Moldavian";

    if (kuerzel=="mr")
        return "Marathi";

    if (kuerzel=="ms")
        return "Malay";

    if (kuerzel=="mt")
        return "Maltese";

    if (kuerzel=="my")
        return "Burmese";

    if (kuerzel=="na")
        return "Nauru";

    if (kuerzel=="ne")
        return "Nepali";

    if (kuerzel=="oc")
        return "Occitan";

    if (kuerzel=="om")
        return "Oromo";

    if (kuerzel=="or")
        return "Oriya";

    if (kuerzel=="pa")
        return "Punjabi";

    if (kuerzel=="ps")
        return "Pashto";

    if (kuerzel=="qu")
        return "Quechua";

    if (kuerzel=="rm")
        return "Rhaeto-Romance";

    if (kuerzel=="rn")
        return "Kirundi";

    if (kuerzel=="ru")
        return "Russian";

    if (kuerzel=="rw")
        return "Kinyarwanda";

    if (kuerzel=="sa")
        return "Sanskrit";

    if (kuerzel=="sd")
        return "Sindhi";

    if (kuerzel=="sg")
        return "Sangho";

    if (kuerzel=="si")
        return "Sinhalese";

    if (kuerzel=="sm")
        return "Samoan";

    if (kuerzel=="so")
        return "Somali";

    if (kuerzel=="sq")
        return "Albanian";

    if (kuerzel=="sr")
        return "Serbian";

    if (kuerzel=="ss")
        return "Siswati";

    if (kuerzel=="st")
        return "Sesotho";

    if (kuerzel=="su")
        return "Sundanese";

    if (kuerzel=="sw")
        return "Swahili";

    if (kuerzel=="ta")
        return "Tamil";

    if (kuerzel=="te")
        return "Telugu";

    if (kuerzel=="th")
        return "Thai";

    if (kuerzel=="tg")
        return "Tajik";

    if (kuerzel=="ti")
        return "Tigrinya";

    if (kuerzel=="tk")
        return "Turkmen";

    if (kuerzel=="tl")
        return "Tagalog";

    if (kuerzel=="tn")
        return "Setswana";

    if (kuerzel=="to")
        return "Tonga";

    if (kuerzel=="ts")
        return "Tsonga";

    if (kuerzel=="tt")
        return "Tatar";

    if (kuerzel=="tw")
        return "Twi";

    if (kuerzel=="ug")
        return "Uighur";

    if (kuerzel=="ur")
        return "Urdu";

    if (kuerzel=="uz")
        return "Uzbek";

    if (kuerzel=="vi")
        return "Vietnamese";

    if (kuerzel=="vo")
        return "Volapuk";

    if (kuerzel=="wo")
        return "Wolof";

    if (kuerzel=="xh")
        return "Xhosa";

    if (kuerzel=="yi")
        return "Yiddish";

    if (kuerzel=="ji")
        return "Yiddish";

    if (kuerzel=="yo")
        return "Yoruba";

    if (kuerzel=="za")
        return "Zhuang";

    if (kuerzel=="zh")
        return "Chinese";

    if (kuerzel=="zu")
        return "Zulu";

    return "xxx";
}

# endif
