/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# ifndef EDITIERFENSTER_CPP
# define EDITIERFENSTER_CPP

# include "Editierfenster.h"

 Editierfenster::Editierfenster (QWidget *parent,int startdebug,Encodieren *uebergabe)
{
    // Speichert das Eltern Widget ab
    eltern=parent;

    // Debuglevel setzen
    debuglevel=startdebug;

    // Speichert das encodierende Objekt in der entsprechende Variable ab
    encodieren=uebergabe;

    // Das Editierfenster erstellen
    setGeometry(40,40,490,70);

    // Erstellt das Editierfeld
    editierFeld = new QLineEdit(this);
    editierFeld->setGeometry(2,2,480,30);

    // Mit diesem Knopf wird der Encodiervorgang mit dem editierten Aufruf gestartet
    editStart = new QPushButton(this);
    editStart->setGeometry(385,40,85,25);

    // Mit diesem Knopf wird der Encodiervorgang abgebrochen
    editAbbrechen = new QPushButton(this);
    editAbbrechen->setGeometry(25,40,85,25);
}

void Editierfenster::aufrufEditieren (const QString& aufruf)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : aufrufEditieren *"<<endl<<endl;
    }

    if(debuglevel==3)
    {
        cout<<" aufruf Variable = "<<aufruf<<endl<<endl;
    }

    // Die Position des Fenster bestimmen
    QRect hauptfenster;
    hauptfenster=eltern->frameGeometry();
    move(QPoint(hauptfenster.left(),(hauptfenster.top()+320)));

    // Das Eiongabe Feld mit den ensprechenden Text fuellen
    editierFeld->setText(aufruf);

    // Momentane Sprache auswaehlen
    sprache=encodieren->getsprache();

    // Knopftexte an die eingestellte Sprache anpassen
    if(sprache=="de")
    {
        editAbbrechen->setText("Abbrechen");
        editStart    ->setText("Start");
    }

    if(sprache=="en")
    {
        editAbbrechen->setText("Abort");
        editStart    ->setText("Start");
    }

    show();

    // den Encodiervorgang  starten lassen wenn der Knopf gedrueckt wird
    QObject::connect(editStart,      SIGNAL(released()),  encodieren,                SLOT(startAufruf()));
    QObject::connect(editStart,      SIGNAL(released()),  this,                      SLOT(hide()));

    // den Encodiervorgang  starten lassen wenn der Knopf gedrueckt wird
    QObject::connect(editAbbrechen,  SIGNAL(released()),  encodieren,                SLOT(reset()));
    QObject::connect(editAbbrechen,  SIGNAL(released()),  this,                      SLOT(hide()));

    // Falls das Stapelfenster geschlossen wird diese Fenster auch ausblenden
    QObject::connect(encodieren,  SIGNAL(hide()),         this,                      SLOT(hide()));

    // den der geaenderte Aufruftext wird an die entsprechende Varibale geschickt
    QObject::connect(editierFeld,    SIGNAL(textChanged(const QString&)),encodieren, SLOT(setAufruf(const QString&)));
}

void Editierfenster::closeEvent(QCloseEvent* schliessen)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : closeEvent *"<<endl<<endl;
    }

    // Das Fenster einmal schliessen
    hide();

    // Und bei Encdieren alles wieder auf Standardwerte setzen
    encodieren->reset();

}
#endif
