/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# include "Einstellungen.h"

# ifndef EINSTELLUNGEN_CPP
# define EINSTELLUNGEN_CPP

void Einstellungen::laden(QString pfad,short versionsnummer,int startdebuglevel)
{
    // Den Anfangs debuglevel festlegen
    debuglevel=startdebuglevel;

    if(debuglevel==3)
   {
        cout<<"einstellungen.cpp: * Methode : laden *"<<endl<<endl;
    }

    if(debuglevel>=3)
    {
        cout<<"einstellungen.cpp: Uebergebener Pfadname = "<<pfad<<endl<<endl;
        cout<<"einstellungen.cpp: Uebergebener Version  = "<<versionsnummer<<endl<<endl;
    }

    // Einmal alle wert ruecksetzen
    ruecksetzen();

    // Der Pfad zum ".dvd2xvid" Ordner
    confpfad=pfad;

    // Versionnummer zuordnen
    version=versionsnummer;

    // Oeffnen der "config" Datei 
    ifstream einlesen((confpfad+"conf"));

    // Kontrolliert ob die Datei geoeffnet werden konnte
    if(!einlesen)
    {
        if(debuglevel==3)
        {
            cout<<"einstellungen.cpp: Konnte keine conf Datei oeffnen, Neue wurde erstellt."<<endl<<endl;
        }

        // erstellt einen versteckten Ordner 
        system(("mkdir "+confpfad));

        // setzt alle Werte auf Standard zurueck
        ruecksetzen();

        // Ordnungsgemaeses schliesen der Confdatei
        einlesen.close();

        // Speichert legt eine Ordentliche Confdatei an
        speichern();
    }
    else
    {
        if(debuglevel==3)
        {
            cout<<"einstellungen.cpp: * Konnte die conf Datei oeffnen"<<endl<<"einstellungen.cpp: *"<<endl;
        }

        // Erste Zeile wird Eingelsen und enthaelt die Versionsnummer der config Datei
        getline(einlesen,temp);

        // Kontrolle ob die erste Zeile eine Versionsnummer oder ein Namen ist
        if(atoi(temp.c_str()))
        {
            versiontemp=atoi(temp.c_str());

            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * Versionsnummer  = "<<versiontemp<<endl;
            }


            // Zeile mit "indirname" wird einglesen und zugewiesen
            getline(einlesen,temp);
            indirname=temp;

            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * Indirname       = "<<temp<<endl;
            }

            // Zeile mit "outfilename" wird einglesen und zugewiesen
            getline(einlesen,temp);
            outfilename=temp;

            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * Outfilename     = "<<temp<<endl;
            }

            // Zeile mit "audioopt" wird einglesen und zugewiesen
            getline(einlesen,temp);
            audioopt=temp;

            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * Audiooptionen   = "<<temp<<endl;
            }

            // Zeile mit "bitrateopt" wird einglesen und zugewiesen
            getline(einlesen,temp);
            bitrateopt=temp;

            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * Bitrateoptionen = "<<temp<<endl;
            }

            // Zeile mit "mountpfad wird einglesen und zugewiesen
            getline(einlesen,temp);
            mountpfad=temp;

            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * Mountpfad       = "<<temp<<endl;
            }

            // Zeilen mit Bool Varibalen werden einglesen und zugewiesen
            einlesen>>boolcartoon;
            einlesen>>bool2pass;
            einlesen>>boolautoaspect;
            einlesen>>boolshutdown;
            einlesen>>boolunmount;
            einlesen>>booleject;
            einlesen>>boolzusammenfuegen;
            einlesen>>boolpart;

            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * Cartoon         = "<<boolcartoon<<endl;
                cout<<"einstellungen.cpp: * 2Pass           = "<<bool2pass<<endl;
                cout<<"einstellungen.cpp: * Autoaspect      = "<<boolautoaspect<<endl;
                cout<<"einstellungen.cpp: * Shutdown        = "<<boolshutdown<<endl;
                cout<<"einstellungen.cpp: * Umount          = "<<boolunmount<<endl;
                cout<<"einstellungen.cpp: * Eject           = "<<booleject<<endl;
                cout<<"einstellungen.cpp: * Zusammenfuegen  = "<<boolzusammenfuegen<<endl;
                cout<<"einstellungen.cpp: * .part           = "<<boolpart<<endl;
            }

            // Zeile mit "debuglevel" wird einglesen und zugewiesen
            getline(einlesen,temp);

            // Die Zeile mit der Sprache einlesen
            getline(einlesen,temp);

            // eingelesen wert sprache zuweisen
            sprache=temp;

            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * Sprache         = "<<temp<<endl;
            }


            // Zeile mit vhqWert einlesen
            getline(einlesen,temp);

            // eingelesen wert sprache zuweisen
            vhqWert=temp;

            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * vhqWert         = "<<temp<<endl;
            }


            // eingelesen wert sprache zuweisen
            einlesen>>boolausgeben;

            // damit zur naechsten Zeile gesprungen wird und der Stream 
            getline(einlesen,temp);

            // Zeile mit Mencoder editieren einlesen
            einlesen>>booleditieren;

            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * booleditieren   = "<<booleditieren<<endl;
            }

            // Zeile mit Mencoder editieren einlesen
            einlesen>>boolTvMode;

            // Wird seit Version 0.7.0 nicht merh unterstuetzt
            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * boolTvMode      = "<<boolTvMode<<endl;
            }

            // Nur wenn die config Datei neuer V0.5.0 ist, diese werte einlesen
            if(51<=versiontemp)
            {
                // ob der Loger aktiv ist
                einlesen>>boolloger;

                if(debuglevel==3)
                {
                    cout<<"einstellungen.cpp: * boolloger       = "<<boolloger<<endl;
                }

                // ob es ein zweites DVD Laufwerk giebt
                einlesen>>bool2DVDLaufwerk;

                if(debuglevel==3)
                {
                    cout<<"einstellungen.cpp: * bool2DVDLaufwerk= "<<bool2DVDLaufwerk<<endl;
                }

                // damit zur naechsten Zeile gesprungen wird und der Stream 
                getline(einlesen,temp);

                // Den Pfad eines evntuell zweiten DVD Laufwerk einlesen 
                getline(einlesen,temp);
                mountpfad2=temp;

                if(debuglevel==3)
                {
                    cout<<"einstellungen.cpp: * mountpfad2      = "<<mountpfad2<<endl;
                }
            }

            if(60<=versiontemp)
            {
                // ob der Loger aktiv ist
                einlesen>>bool2Audiotrack;

                // damit zur naechsten Zeile gesprungen wird und der Stream 
                getline(einlesen,temp);

                if(debuglevel==3)
                {
                    cout<<"einstellungen.cpp: * bool2Audiotrack = "<<bool2Audiotrack<<endl;
                }
            }

            if(70<=versiontemp)
            {
                // Zeile mit "indirname" wird einglesen und zugewiesen
                getline(einlesen,temp);
                audiobitrateopt=temp;

                if(debuglevel==3)
                {
                    cout<<"einstellungen.cpp: * audiobitrateopt = "<<audiobitrateopt<<endl<<endl;
                }
            }


            // Ordnungsgemaeses schliesen der Confdatei
            einlesen.close();
        }
        else
        {
            if(debuglevel==3)
            {
                cout<<"einstellungen.cpp: * Aktualisierte config Datei angelegt"<<endl<<endl;
            }

            // setzt alle Werte auf Standard zurueck
            ruecksetzen();

            // Ordnungsgemaeses schliesen der Confdatei
            einlesen.close();

            // Speichert legt eine Ordentliche Confdatei an
            speichern();

        }
    }
}

void Einstellungen::ruecksetzen(void)
{
    if(debuglevel==2)
    {
        cout<<"einstellungen.cpp: * Methode : ruecksetzen *"<<endl<<endl;
    }

    // Denn Varablien eine Standardwert zuweisen
    indirname          = "/";
    outfilename        = neostring.homepfad()+"out.avi";
    audioopt           = "copy";
    bitrateopt         = "1000";
    audiobitrateopt    = "384";
    vhqWert            = "0";
    mountpfad          = "/mnt/dvd/";
    mountpfad2         = "/mnt/dvd2/";
    sprache            = "en";
    boolcartoon        = false;
    bool2pass          = false;
    boolautoaspect     = false;
    boolshutdown       = false;
    boolunmount        = false;
    booleject          = false;
    boolzusammenfuegen = false;
    boolpart           = false;
    boolausgeben       = false;
    booleditieren      = false;
    boolTvMode         = false;
    bool2DVDLaufwerk   = false;
    boolloger          = false;
    bool2Audiotrack    = false;
}

void Einstellungen::speichern (void)
{
    if(debuglevel==2)
    {
        cout<<"einstellungen.cpp: * Methode : speichern *"<<endl<<endl;
    }

    if(debuglevel==3)
    {
        cout<<"einstellungen.cpp: * Confdatei wird geschrieben !"<<endl<<" *"<<endl;
        cout<<"einstellungen.cpp: * Version         = "<<version<<endl;
        cout<<"einstellungen.cpp: * Indirname       = "<<indirname<<endl;
        cout<<"einstellungen.cpp: * Outfilename     = "<<outfilename<<endl;
        cout<<"einstellungen.cpp: * Audiooptionen   = "<<audioopt<<endl;
        cout<<"einstellungen.cpp: * Bitrateoptionen = "<<bitrateopt<<endl;
        cout<<"einstellungen.cpp: * Mountpfad       = "<<mountpfad<<endl;
        cout<<"einstellungen.cpp: * Cartoon         = "<<boolcartoon<<endl;
        cout<<"einstellungen.cpp: * 2Pass           = "<<bool2pass<<endl;
        cout<<"einstellungen.cpp:* Autoaspect      = "<<boolautoaspect<<endl;
        cout<<"einstellungen.cpp:* Shutdown        = "<<boolshutdown<<endl;
        cout<<"einstellungen.cpp: * Umount          = "<<boolunmount<<endl;
        cout<<"einstellungen.cpp: * Eject           = "<<booleject<<endl;
        cout<<"einstellungen.cpp: * Zusammenfuegen  = "<<boolzusammenfuegen<<endl;
        cout<<"einstellungen.cpp: * .part           = "<<boolpart<<endl;
        cout<<"einstellungen.cpp: * Sprache         = "<<sprache<<endl;
        cout<<"einstellungen.cpp: * vhqWert         = "<<vhqWert<<endl;
        cout<<"einstellungen.cpp: * boolausgeben    = "<<boolausgeben<<endl;
        cout<<"einstellungen.cpp: * booleditiren    = "<<booleditieren<<endl;
        cout<<"einstellungen.cpp: * boolTvMode      = "<<boolTvMode<<endl;
        cout<<"einstellungen.cpp: * boolloger       = "<<boolloger<<endl;
        cout<<"einstellungen.cpp: * bool2DVDLaufwerk= "<<bool2DVDLaufwerk<<endl;
        cout<<"einstellungen.cpp: * mountpfad2      = "<<mountpfad2<<endl;
        cout<<"einstellungen.cpp: * bool2Audiotrack = "<<bool2Audiotrack<<endl;
        cout<<"einstellungen.cpp: * Audiobitrateopt = "<<audiobitrateopt<<endl<<endl;
    }

    // Oeffnen zum schreiben in der "confi    bool2Audiotrack     = false;g" Datei 
    ofstream schreiben((confpfad+"conf"));

    // Schreiben der Versionsnummer von "dvd2xvid"
    schreiben<<version<<endl;

    // Schreiben der einzelnen Variablen in die Datei
    schreiben<<indirname<<endl;
    schreiben<<outfilename<<endl;
    schreiben<<audioopt<<endl;
    schreiben<<bitrateopt<<endl;
    schreiben<<mountpfad<<endl;
    schreiben<<boolcartoon<<endl;
    schreiben<<bool2pass<<endl;
    schreiben<<boolautoaspect<<endl;
    schreiben<<boolshutdown<<endl;
    schreiben<<boolunmount<<endl;
    schreiben<<booleject<<endl;
    schreiben<<boolzusammenfuegen<<endl;
    schreiben<<boolpart<<endl;
    schreiben<<sprache<<endl;
    schreiben<<vhqWert<<endl;
    schreiben<<boolausgeben<<endl;
    schreiben<<booleditieren<<endl;
    schreiben<<boolTvMode<<endl;
    schreiben<<boolloger<<endl;
    schreiben<<bool2DVDLaufwerk<<endl;
    schreiben<<mountpfad2<<endl;
    schreiben<<bool2Audiotrack<<endl;
    schreiben<<audiobitrateopt<<endl;

    // Ordnungsgemaeses schliesen der Confdatei
    schreiben.close();
}
# endif
