/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# ifndef ENCODIEREN_CPP
# define ENCODIEREN_CPP

# include "Encodieren.h"

Encodieren::Encodieren (QWidget *parent,short versionsnummer,int startdebug)
{
    //Debuglevel setzen
    debuglevel=startdebug;


    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Konstructor : Encodieren *"<<endl<<endl;
    }

    // Speichert das Eltern Widget ab
    eltern=parent;

    // Uebergeben Version ablegen
    version=versionsnummer;

    // Erzeugt das ein Timerobjekt fuer das herunterfahren
    timer=new QTimer(eltern);
    connect(timer,    SIGNAL(timeout()),this,SLOT(herunterfahren()));

    // Erzeugt ein Timerobjekt fuer die Konrolle des Aufrufthreads
    wartezeit=new QTimer(eltern);
    connect(wartezeit, SIGNAL(timeout()),this,SLOT(checkaufruf()));

    //Die Datenobjekte einmal erstellen
    for(int var=0;var<10;var++)
    {
        daten[var] = new Daten();
    }

    // Damit im var_reset() der vorherigeZuweisen() nicht schief geht
    durchlauf=0;

    // Die Zeitfelder Varibalen auf Anfangswert setzen
    korrektur="0";
    boolstartzeit=false;
    boolendzeit=false;
    boolfastfertig=false;

    // Die booleditierdialog und boolanzeigen Varibale auf false setzen
    booleditierdialog=false;

    // Damit als erster der erste String beschrieben wird
    var_reset();

    // Laet die Gespeicherten Einstellungen
    laden();

    // Den Loger erstellen
    loger= new Loger(debuglevel);

    // Encodieraufruf Objekt erstellen
    encodieraufruf = new Aufruf();

    // Damit der gespeicherte Standard wert beim 1 Mal aktiviert wird
    daten[durchlauf]->bool2Audiotrack=bool2Audiotrack;
}

QString Encodieren::bauen (int welcherDurchlauf,bool pass)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : bauen *"<<endl<<endl;
    }

    if(pass==false)
    {
        // Die Endzeit Errechnen
        boolendzeit=neostring.zeitrechnen(daten[welcherDurchlauf]->startzeit,
            daten[welcherDurchlauf]->endzeit,korrektur);

         // Kontrolle ob sich die Zeit ueberhaupt geandert hat
        if(!(daten[welcherDurchlauf]->startzeit=="00:00:00"))
        {
            // Damit diese Option dann auch hinzugefuegt wird
            boolstartzeit=true;
        }
        else
        {
        // Damit diese Option nicht hinzugefuegt wird
            boolstartzeit=false;
        }
    }

    // damit der alte Pfad erhalten bleibt (fuer das Oeffne des Fildialogs noetig)
    daten[welcherDurchlauf]->zerlegtOutfilename = daten[welcherDurchlauf]->outfilename;

    // String kontrolliern ob er Leerzeichen enthaelt und diese fuer die Konsole richtig aufbereiten
    neostring.string_zerlegen(daten[welcherDurchlauf]->zerlegtOutfilename);

    // Stellt den Ausgabestring zusammen
    tempausgabe="mencoder dvd://"+daten[welcherDurchlauf]->titelnummer;
    tempausgabe+=" -dvd-device "+daten[welcherDurchlauf]->zerlegtIndirname;

    // Kontrolle ob der Anfang weggeschnitten werden muss
    if(boolstartzeit==true)
    {
        tempausgabe+=" -ss "+daten[welcherDurchlauf]->startzeit;
    }

     // Kontrolle ob das Ende weggeschnitten werden muss
     if(boolendzeit==true)
     {
        tempausgabe+=" -endpos "+daten[welcherDurchlauf]->endzeit;
     }

     // Untertiteln hinzufuehgen wenn etwas ausgewaehlt worden ist
     if(!(daten[welcherDurchlauf]->asid==""))
     {
         tempausgabe+=" -aid "+daten[welcherDurchlauf]->asid;
     }


     // Untertiteln hinzufuehgen wenn etwas ausgewaehlt worden ist
     if(!(daten[welcherDurchlauf]->ssid==""))
     {
         tempausgabe+=" -sid "+daten[welcherDurchlauf]->ssid;
     }

     if(daten[welcherDurchlauf]->audioopt=="mp3lame")
     {
         tempausgabe+=" -oac "+daten[welcherDurchlauf]->audioopt+" -lameopts br=";
         tempausgabe+=daten[welcherDurchlauf]->audiobitrateopt;
     }
     else
     {
         if(daten[welcherDurchlauf]->audioopt=="faac")
        {
            tempausgabe+=" -oac "+daten[welcherDurchlauf]->audioopt+" -faacopts br=";
            tempausgabe+=daten[welcherDurchlauf]->audiobitrateopt;
        }
        else
        {
            tempausgabe+=" -oac "+daten[welcherDurchlauf]->audioopt;
        }
     }

    tempausgabe+=" -ovc xvid -xvidencopts bitrate="+daten[welcherDurchlauf]->bitrateopt;

    // Kontrolle ob "boolcartoon" wahr ist um die entsperchende Option einzufuegen
    if(daten[welcherDurchlauf]->boolcartoon==true)
    {
        tempausgabe+=":cartoon";
    }

    // Kontrolle ob "boolautoapect" wahr ist um die entsperchende Option einzufuegen
    if(daten[welcherDurchlauf]->boolautoaspect==true)
    {
        tempausgabe+=":autoaspect";
    }

    // Den Wert fuer dei Bewegungsabschaetzung hinzufuegen wenn noetig
    if(!(daten[welcherDurchlauf]->vhqWert=="0"))
    {
        tempausgabe+=":vhq="+daten[welcherDurchlauf]->vhqWert;
    }

    // Kontrolle ob "bool2pass" wahr ist um die entsperchende Option einzufuegen
    if(daten[welcherDurchlauf]->bool2pass==true)
    {
        // Kontrolle ob es der erste Durchlauf oder der zweite ist
        if(pass==false)
        {
            tempausgabe+=":pass=1";
        }
        else
        {
            tempausgabe+=":pass=2";
        }
    }

    // Schliesst den Ausgabestream ab
    tempausgabe+=" -o "+daten[welcherDurchlauf]->zerlegtOutfilename;

    // Wenn die Datein nachher zusammengefuegt werden sollen dann fuege .part hinten hinzu
    if(boolzusammenfuegen==true)
    {
        tempausgabe+=".part";
    }

    // Damit die Temporaere "pass Datei von Xvid nicht im Home Ordner herumliegt
    tempausgabe+=" -passlogfile /tmp/2PassStatus.log";

    // Diese Optionen nur beim ersten Durchgang anwenden
    if(pass==false)
    {
        // Damit wenn zusammegfuegt werden soll alle Namen bekannt sind
        ausgabenamen[welcherDurchlauf]=daten[welcherDurchlauf]->zerlegtOutfilename;
    }

    return tempausgabe;
}

void Encodieren::setindirname(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setindirname *"<<endl<<endl;
    }

    // Erstell den Filedialog
    QFileDialog *inname = new QFileDialog(eltern);

    // Falls die Auswahl abgerochen wird merke dir denn alten Wert 
    temp=daten[durchlauf]->indirname;

    // Oeffnet einen Dialog in dem man nur Ordner auswaehlen kann
    daten[durchlauf]->indirname=inname->getExistingDirectory(daten[durchlauf]->indirname,eltern);

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Eingabegabename = "<<daten[durchlauf]->indirname<<endl<<endl;
    }

    // Kontrolle ob der Rueckgabe wert vom Filedialog nicht NULL ist
    if(daten[durchlauf]->indirname==NULL)
    {
        daten[durchlauf]->indirname=temp;
    }

    // damit der alte Pfad erhalten bleibt (fuer das Oeffne des Filedialogs noetig)
    daten[durchlauf]->zerlegtIndirname  = daten[durchlauf]->indirname;

    // String kontrolliern ob er Leerzeichen enthaelt und dies fuer die Konsole richtig aufbereiten
    neostring.string_zerlegen(daten[durchlauf]->zerlegtIndirname);

    // Wenn ein neuer Eingaebordner ausgewaehlt wurde dann wird dieses Signal gesendet mit den Ordnerpfad
    //emit ordnerausgewaehlt(daten[durchlauf]->zerlegtIndirname);
    emit ordnerausgewaehlt(daten[durchlauf]->indirname);
}

void Encodieren::set_indirname(QString name)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : set_indirname *"<<endl<<endl;
    }

    //Weist nur den indrinamen zu
    daten[durchlauf]->zerlegtIndirname=name;
    daten[durchlauf]->indirname=name;

    // Wenn ein neuer Eingaebordner ausgewaehlt wurde dann wird dieses Signal gesendet mit den Ordnerpfad
    emit ordnerausgewaehlt(daten[durchlauf]->zerlegtIndirname);
}

void Encodieren::setoutname (const QString tempoutfilename)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setoutname *"<<endl<<endl;
    }

    // Zur Kontrolle ob der zurueckgegeben Pfad auch etwas enthaelt
    if (!(tempoutfilename==0))
    {
        daten[durchlauf]->outfilename=tempoutfilename;
    }

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Ausgabename = "<<daten[durchlauf]->outfilename<<endl<<endl;
    }
}

QString Encodieren::getoutdirname (void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getoutfilename *"<<endl<<endl;
    }

    // Den Ausgabepfad zurueckgeben
    return daten[durchlauf]->outfilename;
}

void Encodieren::setcartoon (bool cartoon)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setcartoon *"<<endl<<endl;
    }

    // Weist der "boolcartoon" Variable den uebergeben Wert zu
    daten[durchlauf]->boolcartoon=cartoon;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Cartoon Obtimierungs Wert = "<<daten[durchlauf]->boolcartoon<<endl<<endl;
    }
}

void Encodieren::set2pass (bool pass2)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : set2pass *"<<endl<<endl;
    }

    // Weist der "bool2pass" Variable den uebergeben Wert zu
    daten[durchlauf]->bool2pass=pass2;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: 2-Pass Decodierungs Wert = "<<daten[durchlauf]->bool2pass<<endl<<endl;
    }
}

void Encodieren::setautoaspect(bool autoaspect)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setautoaspect*"<<endl<<endl;
    }

    // Weist der "boolautoaspects" Variable den uebergeben Wert zu
    daten[durchlauf]->boolautoaspect=autoaspect;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Autoaspect Options  Wert = "<<daten[durchlauf]->boolautoaspect<<endl<<endl;
    }
}

void Encodieren::setvhq(const QString& vhq)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setvhq*"<<endl<<endl;
    }

    // Weist der "vhqWert" Variable den uebergeben Wert zu
    daten[durchlauf]->vhqWert=vhq;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: VHQ  Wert = "<<daten[durchlauf]->vhqWert<<endl<<endl;
    }
}

void Encodieren::setshutdown (bool shutdown)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setshutdown *"<<endl<<endl;
    }

    // Weist der "bool2pass" Variable den uebergeben Wert zu
    boolshutdown=shutdown;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Schutdown Wert = "<<boolshutdown<<endl<<endl;
    }
}

void Encodieren::setauidoopt (const QString& audio)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setaudioopt *"<<endl<<endl;
    }

    // Weist der "audiopt" Variable den uebergeben Audiooptionswert zu
    daten[durchlauf]->audioopt=audio;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Audio Optionen ausgewaehlt = "<<daten[durchlauf]->audioopt<<endl<<endl;
    }
}

void Encodieren::setbitrateopt (const QString& bitrate)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setbitrateopt *"<<endl<<endl;
    }

    // Weist der "bitrateopt" Variable den uebergeben Bitratewert zu
    daten[durchlauf]->bitrateopt=bitrate;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Bitrate Wert ausgewaehlt = "<<daten[durchlauf]->bitrateopt<<endl<<endl;
    }
}

void Encodieren::setaudiobitrateopt (const QString& bitrate)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setaudiobitrateopt *"<<endl<<endl;
    }

    // Weist der "bitrateopt" Variable den uebergeben Bitratewert zu
    daten[durchlauf]->audiobitrateopt=bitrate;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Audiobitrate Wert ausgewaehlt = "<<daten[durchlauf]->audiobitrateopt<<endl<<endl;
    }
}

void Encodieren::settitel (int titel)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : settitel *"<<endl<<endl;
    }

    // Weist der "titelnummert" Variable den uebergeben Wert zu
    daten[durchlauf]->titelnummer.setNum(titel+1);

    emit  titelausgewaehlt(titel+1);

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Titelnummer ausgewaehlt = "<<daten[durchlauf]->titelnummer<<endl<<endl;
    }
}

void Encodieren::setmountpfad (QString mount)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setmountpfad *"<<endl<<endl;
    }

    // Weist der "mountpfad" Variable den uebergeben Wert zu
    mountpfad=mount;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Mountpfad geaendert = "<<mountpfad<<endl<<endl;
    }
}

void Encodieren::setmountpfad2 (QString mount)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setmountpfad2 *"<<endl<<endl;
    }

    // Weist der "mountpfad" Variable den uebergeben Wert zu
    mountpfad2=mount;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Mountpfad2 geaendert = "<<mountpfad2<<endl<<endl;
    }
}

void Encodieren::setaudio (const QString& audio)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setaudio *"<<endl<<endl;
    }

    // Weist der "alang" Variable den uebergeben Wert zu
    daten[durchlauf]->alang=audio.left(2);

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Uebergeben Audiospur  = "<<audio<<endl;
        cout<<"encodieren.cpp: Audiospur ausgewaehlt = "<<daten[durchlauf]->alang<<endl<<endl;
    }
}

void Encodieren::setuntertitel (const QString& untertitel)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setuntertitel *"<<endl<<endl;
    }

    // Weist der "untertitelnummer" Variable den uebergeben Wert zu
    daten[durchlauf]->untertitelnummer=untertitel.left(2);

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Untertitel ausgewaehlt = "<<daten[durchlauf]->untertitelnummer<<endl<<endl;
        cout<<"encodieren.cpp: Temporaere umwandlungszahl = "<<umwandeln<<endl<<endl;
    }
}

void Encodieren::setbooleject (bool eject)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setbooleject *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "boolunmount"zugewiesen
    booleject=eject;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: boolecejt variable = "<<booleject<<endl<<endl;
    }
}

void Encodieren::setboolunmount (bool unmount)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setunmount *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "boolunmount"zugewiesen
    boolunmount=unmount;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: boolunmount variable = "<<boolunmount<<endl<<endl;
    }
}

void Encodieren::setzusammenfuegen (bool zusammenfuegen)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setzusammenfuegen *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "boolzusammenfuegen"zugewiesen
    boolzusammenfuegen=zusammenfuegen;

    // Die Darstellung im Stapelfenster richtig stellen
    emit part(boolzusammenfuegen);

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: boolzusammnefuegn variable = "<<boolzusammenfuegen<<endl<<endl;
    }
}

void Encodieren::setpart (bool part)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setpart *"<<endl<<endl;
    }

    // Wenn "true" dann sollen die ".part" Datein nachher geloescht werden
    boolpart=part;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: boolpart variable = "<<boolpart<<endl<<endl;
    }
}

void Encodieren::setsprache (QString neuesprache)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setsprache *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "sprache"zugewiesen
    sprache=neuesprache;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: Sprachen variable = "<<boolpart<<endl<<endl;
    }

    // Die Sprache abspeichern
    einstellungen.sprache = sprache;
    einstellungen.speichern();
}

void Encodieren::setasid (QString asid)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setasid *"<<endl<<endl;
    }

    // Den asid (Audio Stream ID) Wert speicheren
    daten[durchlauf]->asid=asid;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: asid Wert = "<<asid<<endl<<endl;
    }
}

void Encodieren::setasid2 (QString asid)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setasid2 *"<<endl<<endl;
    }

    // Den asid (Audio Stream ID) Wert speicheren
    daten[durchlauf]->asid2=asid;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: asid2 Wert = "<<asid<<endl<<endl;
    }
}

void Encodieren::setssid (QString ssid)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setssid *"<<endl<<endl;
    }

    // Den ssid (subtitle Stream ID) Wert speicheren
    daten[durchlauf]->ssid=ssid;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: ssid Wert = "<<ssid<<endl<<endl;
    }
}

void Encodieren::setausgeben (bool ausgeben)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setausgeben *"<<endl<<endl;
    }

    // Waehrend des Encodierens Meldungen an der Standardausgabe ausgeben
    boolausgeben=ausgeben;
}

void Encodieren::setkorrektur (const QString& korrekt)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setkorrektur *"<<endl<<endl;
    }

    korrektur=korrekt;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: korrekur variable = "<<korrektur<<endl<<endl;
    }
}

void Encodieren::setedit (bool edit)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setedit *"<<endl<<endl;
    }

    // Ob die Kommandozeilenparameter noch haendisch editiert werden sollen
    booleditieren=edit;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: booleditier Variable = "<<edit<<endl<<endl;
    }
}

void Encodieren::set2DVDLaufwerk (bool laufwerk)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : set2DVDLaufwerk *"<<endl<<endl;
    }

    bool2DVDLaufwerk=laufwerk;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: bool2DVDLaufwerk Variable = "<<bool2DVDLaufwerk<<endl<<endl;
    }
}

void Encodieren::setLoger (bool aktiv)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setLoger *"<<endl<<endl;
    }

    boolloger=aktiv;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: boolloger Variable = "<<boolloger<<endl<<endl;
    }
}

void Encodieren::set2Audiotrack (bool audiospur)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : set2Audiotrack *"<<endl<<endl;
    }

    bool2Audiotrack=audiospur;
    daten[durchlauf]->bool2Audiotrack=audiospur;

    if(debuglevel==3)
    {
        cout<<"encodieren.cpp: bool2Audiotrack Variable = "<<bool2Audiotrack<<endl<<endl;
    }
}

QString Encodieren::getindirname(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getindirname *"<<endl<<endl;
    }

    // damit der alte Pfad erhalten bleibt (fuer das Oeffne des Fildialogs noetig)
    daten[durchlauf]->zerlegtIndirname   = daten[durchlauf]->indirname;

    // String kontrolliern ob er Leerzeichen enthaelt und dies fuer die Konsole richtig aufbereiten
    neostring.string_zerlegen(daten[durchlauf]->zerlegtIndirname);

    return daten[durchlauf]->indirname;
}

QString Encodieren::getmountpfad (void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getmountpfad *"<<endl<<endl;
    }

    return mountpfad;
}

QString Encodieren::getmountpfad2 (void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getmountpfad2 *"<<endl<<endl;
    }

    return mountpfad2;
}

bool Encodieren::getcartoon(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getcartoon *"<<endl<<endl;
    }

    return daten[durchlauf]->boolcartoon;
}


bool Encodieren::get2pass(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : get2pass *"<<endl<<endl;
    }

    return daten[durchlauf]->bool2pass;
}

bool Encodieren::getautoaspect(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getautoaspect *"<<endl<<endl;
    }

    return daten[durchlauf]->boolautoaspect;
}

QString Encodieren::getvhq(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getvhq *"<<endl<<endl;
    }

    return daten[durchlauf]->vhqWert;
}

bool Encodieren::getshutdown(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getshutdown *"<<endl<<endl;
    }

    return boolshutdown;
}

QString Encodieren::getaudioopt(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getaudioopt *"<<endl<<endl;
    }

    return daten[durchlauf]->audioopt;
}

QString Encodieren::getbitrateopt(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getbitrate *"<<endl<<endl;
    }

    return daten[durchlauf]->bitrateopt;
}

QString Encodieren::getaudiobitrateopt(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getaudibitrate *"<<endl<<endl;
    }

    return daten[durchlauf]->audiobitrateopt;
}

bool Encodieren::getunmount(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getunmount *"<<endl<<endl;
    }

    return boolunmount;
}

bool Encodieren::geteject(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : geteject *"<<endl<<endl;
    }

    return booleject;
}

bool Encodieren::getzusammenfuegen(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getzusammenfuegn *"<<endl<<endl;
    }

    return boolzusammenfuegen;
}

bool Encodieren::getpart(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getpart *"<<endl<<endl;
    }

    return boolpart;
}

bool Encodieren::getausgeben(void)
{
    return boolausgeben;
}

bool Encodieren::geteditieren(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : geteditieren *"<<endl<<endl;
    }

    return booleditieren;
}

QString Encodieren::getsprache (void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getsprache *"<<endl<<endl;
    }

    return sprache;
}

bool Encodieren::get2DVDLaufwerk (void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : get2DVDLaufwerk *"<<endl<<endl;
    }

    return bool2DVDLaufwerk;
}

bool Encodieren::getLoger (void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : getLoger *"<<endl<<endl;
    }

    return boolloger;
}


bool Encodieren::get2Audiotrack (void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : get2Audiotrack *"<<endl<<endl;
    }

    return bool2Audiotrack;
}

void Encodieren::ruecksetzen(void)
{
    // Alle Einstellungen auf die Standardwerte setzen und den Variablen zuweisen
    einstellungen.ruecksetzen();
    zuweisen();

    //Damit nach dem ruecksetzen alle die Anzeigen stimmen
    set_indirname(einstellungen.indirname);
}

void Encodieren::laden(void)
{
    // Die gespeicherten Einstellungen laden und den Variablen zuweisen
    einstellungen.laden((neostring.homepfad()+".dvd2xvid/"),version,debuglevel);
    zuweisen();
}

void Encodieren::zuweisen(void)
{
    // Weist die Werte aus Einstellungen den Varibalen zu
    daten[durchlauf]->indirname          = einstellungen.indirname;
    daten[durchlauf]->outfilename        = einstellungen.outfilename;
    daten[durchlauf]->boolcartoon        = einstellungen.boolcartoon;
    daten[durchlauf]->bool2pass          = einstellungen.bool2pass;
    daten[durchlauf]->boolautoaspect     = einstellungen.boolautoaspect;
    daten[durchlauf]->audioopt           = einstellungen.audioopt;
    daten[durchlauf]->bitrateopt         = einstellungen.bitrateopt;
    daten[durchlauf]->audiobitrateopt    = einstellungen.audiobitrateopt;
    daten[durchlauf]->vhqWert            = einstellungen.vhqWert;
    mountpfad                            = einstellungen.mountpfad;
    mountpfad2                           = einstellungen.mountpfad2;
    boolshutdown                         = einstellungen.boolshutdown;
    boolunmount                          = einstellungen.boolunmount;
    booleject                            = einstellungen.booleject;
    boolzusammenfuegen                   = einstellungen.boolzusammenfuegen;
    boolpart                             = einstellungen.boolpart;
    boolausgeben                         = einstellungen.boolausgeben;
    sprache                              = einstellungen.sprache;
    booleditieren                        = einstellungen.booleditieren;
    boolloger                            = einstellungen.boolloger;
    bool2DVDLaufwerk                     = einstellungen.bool2DVDLaufwerk;
    bool2Audiotrack                      = einstellungen.bool2Audiotrack;
}

void Encodieren::speichern(void)
{
    // Weist die Werte aus Decodiern den Varibalen zu
    einstellungen.indirname          = daten[durchlauf]->indirname;
    einstellungen.outfilename        = daten[durchlauf]->outfilename;
    einstellungen.boolcartoon        = daten[durchlauf]->boolcartoon;
    einstellungen.bool2pass          = daten[durchlauf]->bool2pass;
    einstellungen.boolautoaspect     = daten[durchlauf]->boolautoaspect;
    einstellungen.audioopt           = daten[durchlauf]->audioopt;
    einstellungen.bitrateopt         = daten[durchlauf]->bitrateopt;
    einstellungen.audiobitrateopt    = daten[durchlauf]->audiobitrateopt;
    einstellungen.vhqWert            = daten[durchlauf]->vhqWert;
    einstellungen.mountpfad          = mountpfad;
    einstellungen.mountpfad2         = mountpfad2;
    einstellungen.boolshutdown       = boolshutdown;
    einstellungen.boolunmount        = boolunmount;
    einstellungen.booleject          = booleject;
    einstellungen.boolzusammenfuegen = boolzusammenfuegen;
    einstellungen.boolpart           = boolpart;
    einstellungen.boolausgeben       = boolausgeben;
    einstellungen.booleditieren      = booleditieren;
    einstellungen.sprache            = sprache;
    einstellungen.boolloger          = boolloger;
    einstellungen.bool2DVDLaufwerk   = bool2DVDLaufwerk;
    einstellungen.bool2Audiotrack    = bool2Audiotrack;

    // Speichert die Einstellungen in die Confdatei
    einstellungen.speichern();
}

void Encodieren::vorherigeZuweisen (int var)
{
    if(0<durchlauf)
    {
        daten[var]->indirname          = daten[durchlauf-1]->indirname;
        daten[var]->zerlegtIndirname   = daten[durchlauf-1]->zerlegtIndirname;
        daten[var]->outfilename        = daten[durchlauf-1]->outfilename;
        daten[var]->boolcartoon        = daten[durchlauf-1]->boolcartoon;
        daten[var]->bool2pass          = daten[durchlauf-1]->bool2pass;
        daten[var]->boolautoaspect     = daten[durchlauf-1]->boolautoaspect;
        daten[var]->audioopt           = daten[durchlauf-1]->audioopt;
        daten[var]->bitrateopt         = daten[durchlauf-1]->bitrateopt;
        daten[var]->audiobitrateopt    = daten[durchlauf-1]->audiobitrateopt;
        daten[var]->untertitelnummer   = daten[durchlauf-1]->untertitelnummer;
        daten[var]->alang              = daten[durchlauf-1]->alang;
        daten[var]->titelnummer        = daten[durchlauf-1]->titelnummer;
        daten[var]->vhqWert            = daten[durchlauf-1]->vhqWert;
        daten[var]->bool2Audiotrack    = daten[durchlauf-1]->bool2Audiotrack;
    }
}

void Encodieren::vorschau(void)
{
    vorschaustring="gmplayer dvd://"+daten[durchlauf]->titelnummer+" -dvd-device "+daten[durchlauf]->zerlegtIndirname;

    // Die Vorschau mit den richtigen Ton abspielen
    if(!(daten[durchlauf]->asid==""))
    {
        vorschaustring+=" -aid "+daten[durchlauf]->asid;
    }

    // Die Vorschau mit den richtigen Untertitlen abspielen
    if(!(daten[durchlauf]->ssid==""))
    {
        vorschaustring+=" -sid "+daten[durchlauf]->ssid;
    }

    // Damit man dem Aufruf auch sieht
    cout<<endl<<vorschaustring<<endl<<endl;

    // Vorschau ausfueren und den Rueckgabewert kontrollieren
    if(!(system(vorschaustring)==256))
    {
        // Wenn der Rueckgabe wert nicht "256" ist starte nochmal mit den "mplayer" Kommando
        vorschaustring.remove(1,0);
        system(vorschaustring);
    }
}

void Encodieren::starten(void)
{
    // Hauptfenster unsichtbar machen
    emit verstecken();

    // Startet dann den Eigentlichen Encodiervorgang
    checkaufruf();
}

void Encodieren::herunterfahren(void)
{
    // die Timer schleife auch wieder stoppen
    timer->stop();

    if(boolshutdown==true)
    {
        cout<<" poweroff &"<<endl;

        // Mit diesem Befehl wird der Computer herunter gefahren
        system("poweroff &");

        // Programm beenden
        emit runterfahren();
    }
    else
    {
        // Damit wird der Wert wieder richtig gestellt wie er in der GUI angezeigt wird
        boolshutdown=true;
    }
}

void Encodieren::anhaengen (void)
{
    if(durchlauf<=8)
    {
        // den momentane Durchlauf auf aktiv setzen
        daten[durchlauf]->aktivieren(true);

        // Kontrolle ob der letzte Dateinamen auch so geheissen hat
        if(durchlauf>0)
        {
            if(daten[durchlauf]->outfilename==daten[durchlauf-1]->outfilename)
            {
                // Variablen initzaliesieren
                int var1    =1,
                    varpunkt=0;
                temp        ="";

                // Abspeichern wo der Punkt liegt
                varpunkt=daten[durchlauf]->outfilename.findRev(".",-1,true);

                // Kontrollieren ob das erste Zeichen ein Unterstrich ist
                if(daten[durchlauf]->outfilename.mid(varpunkt-2,1)=="_")
                {
                     // Die Position mit der Zahl in einem String abspeichern
                     temp=daten[durchlauf]->outfilename.mid(varpunkt-1,1);

                     // Die Zahl die nach dem "_" steht in ein eINt umwandeln
                     var1=temp.toInt(NULL,10);

                     // Die Zahl um 1 erhoehen
                     daten[durchlauf]->outfilename.replace(varpunkt-1,1,temp.setNum(var1+1));
                 }
                 else
                 {
                     // Einen Unterstrich und die Zahl 1 einfuegen
                     daten[durchlauf]->outfilename.insert(varpunkt,("_"+temp.setNum(var1)));
                 }
            }
        }

        // Fuer die Anzeige im dem Stapelfenster
        emit aufruf(daten[durchlauf]->outfilename,daten[durchlauf]->titelnummer,daten[durchlauf]->boolcartoon,
                    daten[durchlauf]->bool2pass,daten[durchlauf]->boolautoaspect);

        durchlauf++;

        // Damit alle Zeiten zuruckgesetz werden
        emit zeitfelderrucksetzen();

        // Damit der neue Datensatz mit den alten werten arbeiten kann
        vorherigeZuweisen(durchlauf);
    }
    else
    {
        ueberschrift=tr("Stapelverarbeitung");
        haupttext   =tr("Maximale Auftragszahl erreicht.");

        // Meldung ausgeben nicht mehr als zehn Auftraege gespeichert werden koennen 
        QMessageBox::critical(eltern,ueberschrift,haupttext,
                              QMessageBox::Ok,QMessageBox::NoButton,QMessageBox::NoButton);
    }
}

void Encodieren::setstartzeit(const QString& zeit)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setstartzeit *"<<endl<<endl;
    }

    // Weist den uebergeben String der Varibale "startzeit" zu
    daten[durchlauf]->startzeit=zeit;

    if(debuglevel>=3)
    {
        cout<<"encodieren.cpp: startzeit = "<<daten[durchlauf]->startzeit<<endl<<endl;
    }
}

void Encodieren::setendzeit(const QString& zeit)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : setendzeit *"<<endl<<endl;
    }

    // Weist den uebergeben String der Varibale "startzeit" zu
    daten[durchlauf]->endzeit=zeit;

    if(debuglevel>=3)
    {
        cout<<"encodieren.cpp: endzeit = "<<daten[durchlauf]->endzeit<<endl<<endl;
    }
}

void Encodieren::zusammenfuegen (void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : zusammenfuegen *"<<endl<<endl;
    }

    // Kontrolle ob Zusammen fuegen uberhaupt noetig ist
    if(durchlauf>0)
    {
        // Aufruf fuer das zusammenfuegn zusammenabuen
        tempausgabe=" avimerge -i";

        for(int zaehler=0;zaehler<durchlauf;zaehler++)
        {
            tempausgabe+=" "+ausgabenamen[zaehler]+".part";
        }

        tempausgabe+=" -o "+ausgabenamen[0];

        // Ausgabe and die Standardausgabe
        cout<<endl<<" "<<tempausgabe<<endl<<endl;

        // Nur Simuliertes schreiben keine wirkliche Decodierung wenn Debuglevel nicht 0 ist
        if(debuglevel<1)
        {
            // Zusammenfuegen durch fuehren lassen
            system(tempausgabe);
            cout<<endl;
        }

        // Alle temporaeren part dateien loeschen wenn dies ausgewaehlt worden ist
        delpart();
    }
}

void Encodieren::delpart (void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : delpart *"<<endl<<endl;
    }

    //Kontrolle ob die Datein wirklilch geloescht werden sollen
    if(boolpart==true)
    {
        // Aufruf fuer das loeschen der .part Datein zusammenabuen
        for(int zaehler=0;zaehler<durchlauf;zaehler++)
        {
            tempausgabe="rm "+ausgabenamen[zaehler]+".part";

            // Ausgabe and die Standardausgabe
            cout<<" "<<tempausgabe<<endl<<endl;

            if(debuglevel<1)
            {
                // Entsprechende Datei loeschen
                system(tempausgabe);
            }
        }
    }
}

void Encodieren::encodieren(void)
{
    // zuerset den Auftrag erstellen und das Fenster sichtbar machen
    anhaengen();

    // Begint mit den Encodieren
    starten();
}

void Encodieren::var_reset(void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : var_reset *"<<endl<<endl;
    }

    // Damit der erste Datensatz mit den alten werten arbeiten kann
    vorherigeZuweisen(0);

    // Stringvar und durchlauf zuruecksetzen
    durchlauf       =0;
    zaehler         =0;
    startzeit       =0;
    bool2pass       = false;
    boolanhalten    = false;
    boolvoranhalten = false;
    boolerster      = true;
    boolletzter     = false;

    // Auch die Datenobjekte loeschen
    for(int var=0;var<10;var++)
    {
        daten[var]->aktivRuecksetzen();
    }
}

bool Encodieren::zyklusrunning (void)
{
    // Den Wert abspeichern damit er gleich zurueckgegeben werden kann
    bool booltemp=boolfastfertig;

    // Den Wert fuer den naechsten durchgang abspeichern
    boolfastfertig=encodieraufruf->running();

    if(boolfastfertig==false)
    {
        emit status(tr("* 2 Audiospur encodieren *"));
    }

    return booltemp;
}


void Encodieren::checkaufruf (void)
{
    // kontrolliert ob der Decodierauftrag beentet ist
    if((zyklusrunning()==false) & (booleditierdialog==false))
    {
        // die Kontrollzeit stoppen
        wartezeit->stop();

        // Beim ersten Durchlauf noch nicht kontrollieren
        if(boolerster==false)
        {
            if((bool2pass==false)&(boolanhalten==false))
            {
                // Wenn im 2Pass-Modus encodiert werden soll dann setze bool2pass auf "true"
                if(daten[zaehler]->bool2pass==false)
                {
                    // Eine eventuelle 2 Audiospur herausfiltern und zusammen bauen
                    if(daten[zaehler-1]->bool2Audiotrack==true)
                    {
                        audiospur2();
                    }
                }
                else
                {
                    // Eine eventuelle 2 Audiospur herausfiltern und zusammen bauen
                    if(daten[zaehler-1]->bool2Audiotrack==true)
                    {
                        audiospur2();
                    }
                }
            }
        }

        // Damit beim nchsten mal die 2 Audiospur konrolliert wird
        boolerster=false;

        // boolfastfertig zurucksetzten
        boolfastfertig=false;

        if(debuglevel>=2)
        {
            cout<<"encodieren.cpp: Threadaufruf ist fertig! *"<<endl<<endl;
        }

        if(!(startzeit==0))
        {
            // Die momentane Zeit in Sekundne abspeichern
            endzeit=time(NULL);

            if(debuglevel==3)
            {

                cout<<"encodieren.cpp: Endzeit   seit 1.1.1970 in sec:"<<endzeit<<endl<<endl;
            }

            // Zwischenergebnis der gesamten Dauer der Encodierung in Sekunden
            tempzeit=endzeit-startzeit;

            // Die Zeit in einen String umwandeln
            dauer=neostring.longrechnen(tempzeit);

            if(debuglevel==3)
            {
                cout<<"encodieren.cpp: Zwischenergebnis von Start- und Endzeit: "<<tempzeit<<endl;
                cout<<"encodieren.cpp: Encodierungsdauer als QString          : "<<dauer   <<endl<<endl;
            }

        }

        if((zaehler<durchlauf)&(boolanhalten==false))
        {
            // Kontrolle ob in diesen Datensatz ueberhaupt etwas drinnen steht
            if(daten[zaehler]->aktiv()==true)
            {
                // Schauen ob das der Letzte Durchlauf ist (noch nicht mit 2-Pass)
                if(zaehler==durchlauf-1)
                {
                    boolletzter=true;
                }

                if(bool2pass==false)
                {
                    // Die momentane Zeit in Sekundne abspeichern
                    startzeit=time(NULL);

                    if(debuglevel==3)
                    {
                        cout<<"encodieren.cpp: Startzeit seit 1.1.1970 in sec:"<<startzeit<<endl<<endl;
                    }

                    // Den Ausgabestring zusammenbauen lassen
                    ausgabe=bauen(zaehler,false);

                    // Damit im Stapelfenster der Aktuelle Auftrag angezeit wird
                    emit aktiveZeile(zaehler,bool2pass,boolletzter);

                    // Wenn im 2Pass-Modus encodiert werden soll dann setze bool2pass auf "true"
                    if(daten[zaehler]->bool2pass==true)
                    {
                        bool2pass=true;
                    }
                    else
                    {
                        // Wenn kein 2-Pass erfolgt dann zaehle
                        zaehler++;
                    }
                }
                else
                {
                    // Kontrollieren ob er beim Naechsten durchlauf gestoppt werden soll
                    if(boolvoranhalten==true)
                    {
                        boolanhalten=true;
                    }

                    // Den Ausgabestring zusammenbauen lassen
                    ausgabe=bauen(zaehler,true);

                    // Damit im Stapelfenster der Aktuelle Auftrag angezeit wird
                    emit aktiveZeile(zaehler,bool2pass,boolletzter);

                    // boll2pass wieder auf "false" setzen damit der naechste Durchlauf beim 1pass begint
                    bool2pass=false;

                    zaehler++;
                }


                // Kontrolle ob die Ausgabe editiert werden soll
                if(booleditieren==true)
                {
                    // Damit der Startschleife von checkaufruf unterbrochen wird
                    booleditierdialog=true;

                    // Den Dialog erstellen und anzeigen
                    emit aufrufEditieren(ausgabe);
                }
                else
                {
                    // den Encodiervorgang  starten lassen
                    startAufruf();
                }

            }
            else
            {
                zaehler++;
            }

            // Mit Wartezeit start wird immer kontrolliert ob er schon fertig ist
            wartezeit->start(500);
        }
        else
        {

            if(boolloger==true)
            {
                // Die Logdatei aktualisieren lassen
                schreibeLog();
            }

           // Wenn die Decodierten Datein zusammengefuegt werden sollen dann fuere zusammenfuegen aus
           if(boolzusammenfuegen==true)
           {
               zusammenfuegen();
           }



           // kontrolliere ob die dvd nachher entbunden werden soll
           if(boolunmount==true)
           {
               emit umount();

               // kontrolliere ob die dvd lade geoeffnet werden soll
               if(booleject==true)
               {
                   system(("eject "+mountpfad));
                   cout<<endl<<"eject "<<mountpfad<<endl;

                   // Wenn ein zweites DVD Laufwerk aktive ist dann oeffne auch dieses
                   if(bool2DVDLaufwerk==true)
                   {
                       system(("eject "+mountpfad2));
                       cout<<endl<<"eject "<<mountpfad2<<endl;
                   }
               }
           }

           if(debuglevel<1)
           {
                // Wenn boolshutdown aktiviert ist dan fahre das System herunter
                if((boolshutdown==true)&(boolanhalten==false))
                {
                    // Die 15 Sekunden Verzoegerung starten
                    timer->start(15000);

                    ueberschrift=tr("Wirklich Heruntergefahren?");
                    haupttext   =tr("Der Computer wird 15 Sekunden heruntergefahren oder abbrechen");


                    // Die zwischen Varibale zuruecksetzen
                    shutdownAbbrechen=1;

                    //Wenn man es sich doch anders Ueberlegt hat kamm man hier den Encodiervorgang abbrechen 
                    shutdownAbbrechen = QMessageBox::critical(eltern,ueberschrift,haupttext,
                                        QMessageBox::Cancel,QMessageBox::NoButton,QMessageBox::NoButton);

                    // Den Rueckgabe wert des Dialogs auswerten
                    if((shutdownAbbrechen==2)||(shutdownAbbrechen==0))
                    {
                        // herunterfahren verhindern
                        boolshutdown=false;
                    }
                }
            }

            // Bei boolanhalten ist kes nicht merh noetig ferig zu schicken
            if(boolanhalten==false)
            {
                // Der Decodiervorgang ist abgeschlossen sende das Signal feritg nach 4 sekundne verzoegerung
                QTimer::singleShot(1000*3,this,SIGNAL(fertig()));
            }
            else
            {
                emit fertig();
            }

            // Die Zeit auch stoppen die in der Satuszeile laeuft
            emit stopStapelzeit();

            // Und setze die Variablen zurueck
            var_reset();
        }
    }
    else
    {
        if(boolfastfertig==true)
        {
            // Meldungen vom Aufruf holen, wenn gerade encodiert wird
            meldungen();
        }
    }
}

void Encodieren::anhalten(void)
{
    // im 2Pass gleich "boolanhalten" auf true setzen
    if(bool2pass==false)
    {
        boolanhalten=true;
    }
    else
    {
        // wenn noch ein 2Durchlauf kommt dann setzte den voralarm
        boolvoranhalten=true;
    }
}

void Encodieren::abbrechen(void)
{
    ueberschrift=tr("Wirklich Abbrechen?");
    haupttext   =tr("Wenn sie jetzt Abbrechen wird der aktuelle Film,\nnicht vollstaendig sein! Trotzdem Abbrechen?");



    // Nocheinmal Rueckfragen ob der Aufruf wircklich abgebrochen werden soll
    if(1==QMessageBox::warning(eltern,ueberschrift,haupttext,QMessageBox::Ok,QMessageBox::Cancel))
    { 
        // Damit nach dem Abbrechen nicht weiter encodiert wird
        boolanhalten=true;
        booleditierdialog=false;

        // Den Thread abrechen der gerade am encodieren ist
        encodieraufruf->terminate();

        // Damit auch ein eventuelles Editierfentser geschlossen wird
        emit hide();

        // Optische kleinichkeit
        cout<<endl<<endl;
    }
}

void Encodieren::meldungen (void)
{
    emit status(encodieraufruf->meldungen());
}

void Encodieren::startAufruf (void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : startAufruf *"<<endl<<endl;
    }

    // Nur Simuliertes schreiben keine wirkliche Decodierung
    cout<<endl<<ausgabe<<endl<<endl;

    //Damit der Erste zyklussrunning aufruf richtig ist
    boolfastfertig=true;

    if(debuglevel<1)
    {
       // Den Encodieraufruf an das Threadobjekt senden
       encodieraufruf->setAufruf(ausgabe,boolausgeben);

       // Den Thread starten mit den entsprechenden Aufruf
       encodieraufruf->start();
    }

    // Fuer den Fall das "startAufruf" von "gui::aufrufEditieren" gestartet wurde
    booleditierdialog=false; 
}

void Encodieren::setAufruf (const QString& uebergabe)
{
    // Den Encodier Aufruftext aendern
    ausgabe=(uebergabe);
}

void Encodieren::reset(void)
{
    // Damit nach dem Abbrechen nicht weiter encodiert wird
    boolanhalten=true;

    // Wieder auf default Wert setzen
    booleditierdialog=false;
}

void Encodieren::schreibeLog (void)
{
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : schreibeLog *"<<endl<<endl;
    }

    // Den Pfad der Logdatei setzen
    loger->setPfad(neostring.homepfad()+".dvd2xvid/");

    // Die Zeit an den Loger schicken
    loger->setZeit(dauer);

    // Den Titel des Films an den Loger schicken
    loger->setTitel(ausgabe);

    // Die Log datei jetzt aktulaisieren
    loger->schreiben();
}

void Encodieren::audiospur2 (void)
{
    QString tempZusammenbauen;
    if(debuglevel>=2)
    {
        cout<<"encodieren.cpp: * Slot : audiospur2 *"<<endl<<endl;
    }

    if(!(daten[zaehler-1]->asid2==""))
    {
        tempZusammenbauen="mplayer -dumpaudio -dumpfile /tmp/second_audiotrack.ac3 dvd://";
        tempZusammenbauen+=daten[zaehler-1]->titelnummer;
        tempZusammenbauen+=" -dvd-device ";
        tempZusammenbauen+=daten[zaehler-1]->zerlegtIndirname;
        tempZusammenbauen+=" -aid ";
        tempZusammenbauen+=daten[zaehler-1]->asid2;

        // Die Ausgabe auch sichtabr machen
        cout<<tempZusammenbauen<<endl<<endl;

        // Aktion ausfueheren
        if(debuglevel<1)
        {
            system(tempZusammenbauen);
        }

        // Die 2 Audiostreams nun zusammen fuegen
        tempZusammenbauen="avimerge -i";
        tempZusammenbauen+=daten[zaehler-1]->zerlegtOutfilename;
        tempZusammenbauen+=" -o ";
        tempZusammenbauen+=daten[zaehler-1]->zerlegtOutfilename;
        tempZusammenbauen+=".temp -p /tmp/second_audiotrack.ac3";

        // Die Ausgabe auch sichtabr machen
        cout<<tempZusammenbauen<<endl<<endl;

        // Aktion ausfueheren
        if(debuglevel<1)
        {
            system(tempZusammenbauen);
        }

        //Den richtigen Namen wiederherstellen
        tempZusammenbauen="mv ";
        tempZusammenbauen+=daten[zaehler-1]->zerlegtOutfilename;
        tempZusammenbauen+=".temp ";
        tempZusammenbauen+=daten[zaehler-1]->zerlegtOutfilename;

        // Die Ausgabe auch sichtabr machen
        cout<<endl<<tempZusammenbauen<<endl<<endl;

        // Aktion ausfueheren
        if(debuglevel<1)
        {
            system(tempZusammenbauen);
        }

        // Die Temporaere Audiodatei loeschen
        tempZusammenbauen="rm  /tmp/second_audiotrack.ac3";

        // Die Ausgabe auch sichtabr machen
        cout<<tempZusammenbauen<<endl<<endl;

        // Aktion ausfueheren
        if(debuglevel<1)
        {
            system(tempZusammenbauen);
        }
    }
}

# endif
