/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# include "Gui.h"

# ifndef GUI_CPP
# define GUI_CPP

Gui::Gui(int startdebuglevel,short versionsnummer,QString versionsname)
{
    // Den Anfangs debuglevel festlegen
    debuglevel=startdebuglevel;

    if(debuglevel>=2)
    {
        cout<<"gui.cpp: Startdebuglevel : "<<startdebuglevel<<endl<<endl;
        cout<<"gui.cpp: Versionsnummer  : "<<versionsnummer<<endl<<endl;
    }

    hoehe      = 645;                      // fuer die Hoehe des Fensters
    breite     = 510;                      // die Breite des Fensters
    zeile      =  30;                      // fuer die Vertikale   Position des Labels
    spalte_1   =  10;                      // fuer die  1 Horizontale Position des Labels
    spalte_2   = 255;                      // fuer die  2 Horizontale Position des Labels


    // Damit der Erste Aufruf von Mount auch stimmt
    boolmount          = false;
    boolmount2         = false;
    bool2mounten       = false;
    bool2Spracheaktive = false;

    // Damit  QApplication ruhe gibt
    char *argv[1]={""};
    int argc=0;

    // Translator einmal anlegen (muss for dem Hauptwidget passieren)
    QTranslator translator(0);

    // Instantierung eines QApplication-Objekts; immer notwendig
    QApplication app(argc,argv);

    // Erstellen des Hauptfensters
    window = new QWidget();

    // Diese Klasse enthaelt die Slots fuer die uebergabe an Mencoder
    encodieren = new Encodieren(window,versionsnummer,debuglevel);

    // Die Abgespeicherte Sprache hohlen
    temp=encodieren->getsprache();

    // Die Sprtachdatei zusammenabuen
    temp+=".qm";

    // Als Standard Sprache deutsch nehmen
    translator.load(temp,"/usr/share/dvd2xvid/language/");

    // Das TRanslatorobjekt installieren
    app.installTranslator(&translator);

    // Denn Versionsnamen abspeichern
    name=versionsname;

    // Fuer die Anzeige des Fensternamens in der Teitelzeile
    window->setCaption(name);

    // Ermittelt die Bildschirm Groesse und Plaziert das Fenster fast ganz rechts
    positionieren();

    // Wien QPixmap Objekt erzeugen dem das Bild "dvd.png" uebergeben wird
    QPixmap *icon = new QPixmap("/usr/share/dvd2xvid/icons/dvd2xvid32.png");

    // Dem Programm das Icon zuweisen
    window->setIcon(*icon);

    // In diesen Fenster wird dann der editieraufruf angepasst
    editierfenster= new Editierfenster(window,debuglevel,encodieren);

    // fuegt die Menuebar hinzu
    menubar= new Menuebar(window,encodieren,debuglevel);

    // Fuer das Mounten der DVD
    process_mounten = new QProcess(this);

    // Das Stapelfenster erstellen
    stapel = new Stapelfenster(window,poshor,posver+hoehe+29,encodieren);

    // Legt die Zwieschenrauume der einzelnen Element fest
    short spacing=10;

    // Legt die Zwischenraeume vom Layoutwidget fest
    short margin =5;

    /************************************/
    /*        Layouts Breich DVD        */
    /************************************/

    // Die Einzelene Reihen Widgets
    hlayout1 = new QHBoxLayout();
    hlayout1->setSpacing(spacing);
    hlayout1->setMargin(margin);

    hlayout2 = new QHBoxLayout();
    hlayout2->setSpacing(spacing);
    hlayout2->setMargin(margin);

    hlayout3 = new QHBoxLayout();
    hlayout3->setSpacing(spacing);
    hlayout3->setMargin(margin);

    hlayout4 = new QHBoxLayout();
    hlayout4->setSpacing(spacing);
    hlayout4->setMargin(margin);

    // Das DVD Bild uebergeben
    labelbilddvd = new QLabel(window);
    labelbilddvd->setPixmap(QPixmap("/usr/share/dvd2xvid/icons/dvd.png"));

    // Label fuer "outname"
    labelindirname = new QLabel(window);
    labelindirname->setText(tr("Die DVD oder den Ort des DVD-Ordners auswhlen:"));

    // Label fuer "outnaladenme"
    labeloutname = new QLabel(window);
    labeloutname->setText(tr("Pfad Ausgabedatei:"));

    // Mountet die DVD
    mount = new QPushButton(window);

    // Mountet die DVD im Laufwerk 2 wenn aktive
    mount2 = new QPushButton(window);
    mount2->setText("Mount DVD 2");
    mount2->hide();

    // Erstellt den Konpf "Ordner fuer Eingabe auswaehlen" 
    indir = new QPushButton(tr("Datei"),window);

    // Erstellt den Konpf "Ausgabe Datei auswaehlen"
    outfile = new QPushButton(window);

    // Abgrenzungslinie zwischen Layout 2 + 3
    linie1 = new QFrame(window);
    linie1->setFrameStyle(QFrame::HLine|QFrame::Plain);
    linie1->setPaletteForegroundColor(Qt::gray);
    linie1->setLineWidth(1);


    // Alle Widgets fuer die Dateiauswahl einfuegen
    //Zeile 1
    hlayout1->addWidget(labelbilddvd,1);
    hlayout1->addWidget(labelindirname,10,Qt::AlignHCenter);

    // Zeile 2
    hlayout2->addWidget(mount);
    hlayout2->addWidget(mount2);
    hlayout2->addWidget(indir);

    // Zeile 3 - Ablage Ort der fertigen Datei
    hlayout3->addWidget(labeloutname,1,Qt::AlignHCenter);
    hlayout3->addWidget(outfile,3);

    //Abgenzungslinie
    hlayout4->addWidget(linie1);


    /************************************/
    /*        Layouts Breich Track      */
    /************************************/

    // Die Einzelene Reihen Widgets
    hlayout5 = new QHBoxLayout();
    hlayout5->setSpacing(spacing);
    hlayout5->setMargin(margin);

    hlayout6 = new QHBoxLayout();
    hlayout6->setSpacing(spacing);
    hlayout6->setMargin(margin);

    // Das Bild Bild uebergeben
    labelbildplay = new QLabel(window);
    labelbildplay->setPixmap(QPixmap("/usr/share/dvd2xvid/icons/play.png"));

    // Beschriftung fuer "labeltitel" (Welcher Titel decodiert werden soll)
    labeltitle = new QLabel(window);
    labeltitle->setText(tr("Welchen Titel encodieren:"));

    //Vorschau mit den bissherigen Einstellungen
    vorschau = new QPushButton(window);
    vorschau->setText(tr("Vorschau"));

    // Darin wird dann ausgewaehlt welcher Titel decodiert werden soll
    cotitel = new QComboBox(window);

    // Abgrenzungslinie zwischen Layout 2 + 3
    linie2 = new QFrame(window);
    linie2->setFrameStyle(QFrame::HLine|QFrame::Plain);
    linie2->setPaletteForegroundColor(Qt::gray);
    linie2->setLineWidth(1);

    // Alle Widgets fuer die Bildauswahl einfuegen
    //Zeile 1
    hlayout5->addWidget(labelbildplay,1);
    hlayout5->addWidget(labeltitle,2);
    hlayout5->addWidget(cotitel,5);
    hlayout5->addWidget(vorschau,1);

    //Abgenzungslinie
    hlayout6->addWidget(linie2);

    /************************************/
    /*       Layouts Breich Bild        */
    /************************************/

    // Die Einzelene Reihen Widgets
    hlayout7 = new QHBoxLayout();
    hlayout7->setSpacing(spacing);
    hlayout7->setMargin(margin);

    hlayout8 = new QHBoxLayout();
    hlayout8->setSpacing(spacing);
    hlayout8->setMargin(margin);

    hlayout9 = new QHBoxLayout();
    hlayout9->setSpacing(spacing);
    hlayout9->setMargin(margin);

    hlayout10 = new QHBoxLayout();
    hlayout10->setSpacing(spacing);
    hlayout10->setMargin(margin);

    labelbildueberschrift = new QLabel(window);
    labelbildueberschrift->setText(tr("Bildqualitaet Einstellungen"));

    // Das Bild Bild uebergeben
    labelbildbild = new QLabel(window);
    labelbildbild->setPixmap(QPixmap("/usr/share/dvd2xvid/icons/bild.png"));

    // Beschriftung fuer "labelbitrate" (Bitrate Encodierungs Optionen)
    labelbitrate = new QLabel(window);
    labelbitrate->setText(tr("Bitrate Wert :"));

    // Beschriftung fuer "cbcartoon" (CartoonOptimierung aktivieren)
    labelcartoon = new QLabel(window);
    labelcartoon->setText(tr("Cartoon Option:"));

    // Beschriftung fuer "cb2pass" (2-Pass Decodierung aktivieren)
    label2pass = new QLabel(window);
    label2pass->setText(tr("2-Pass Option:"));

    // Beschriftung fuer "cbautoaspect" (CartoonOptimierung aktivieren)
    labelautoaspect = new QLabel(window);
    labelautoaspect->setText(tr("Autoaspect Option:"));

    // Beschriftung fuer "cbvhq" (CartoonOptimierung aktivieren)
    labelvhq = new QLabel(window);
    labelvhq->setText(tr("Bewegungsabschaetzung :"));

    // ob mit Cartonn Optimierung gearbeitet werden soll
    cbcartoon = new QCheckBox(window);

    // ob im 2-Pass Modus Decodiert werden soll soll
    cb2pass = new QCheckBox(window);

    // Ob die Seitenverhaeltnise automatisch berechnet werden sollen
    cbautoaspect = new QCheckBox(window);

    // Darin wird dann ausgewaehlt mit welcher Bitrate das Bild konvertiert werden soll
    cobitrate = new QComboBox(window);

    // Eintraege fuer "cobitrate"
    cobitrate->insertItem("200");
    cobitrate->insertItem("400");
    cobitrate->insertItem("600");
    cobitrate->insertItem("800");
    cobitrate->insertItem("1000");
    cobitrate->insertItem("1200");
    cobitrate->insertItem("1400");
    cobitrate->insertItem("1600");
    cobitrate->insertItem("1800");
    cobitrate->insertItem("2000");

    // Mit welcher VHQ Qualitaet gearbeite werden soll
    cobvhq = new QComboBox(window);

    // Eintraege fuer "covhq"
    cobvhq->insertItem("0");
    cobvhq->insertItem("1");
    cobvhq->insertItem("2");
    cobvhq->insertItem("3");
    cobvhq->insertItem("4");

    // Abgrenzungslinie zwischen Layout 2 + 3
    linie3 = new QFrame(window);
    linie3->setFrameStyle(QFrame::HLine|QFrame::Plain);
    linie3->setPaletteForegroundColor(Qt::gray);
    linie3->setLineWidth(1);

    // Alle Widgets fuer die Bildauswahl einfuegen
    //Zeile 1
    hlayout7->addWidget(labelbildbild,1);
    hlayout7->addWidget(labelbildueberschrift,2);

    // Zeile 2
    hlayout8->addWidget(labelbitrate,1);
    hlayout8->addWidget(cobitrate,1);
    hlayout8->addWidget(labelvhq,1);
    hlayout8->addWidget(cobvhq,1);

    // Zeile 2
    hlayout9->addWidget(label2pass,1);
    hlayout9->addWidget(cb2pass,1);
    hlayout9->addWidget(labelautoaspect,1);
    hlayout9->addWidget(cbautoaspect,1);
    hlayout9->addWidget(labelcartoon,1);
    hlayout9->addWidget(cbcartoon,1);

    //Abgenzungslinie
    hlayout10->addWidget(linie3);

    /************************************/
    /*        Layouts Breich Ton        */
    /************************************/

    // Die Einzelene Reihen Widgets
    hlayout11 = new QHBoxLayout();
    hlayout11->setSpacing(spacing);
    hlayout11->setMargin(margin);

    hlayout12 = new QHBoxLayout();
    hlayout12->setSpacing(spacing);
    hlayout12->setMargin(margin);

    hlayout13 = new QHBoxLayout();
    hlayout13->setSpacing(spacing);
    hlayout13->setMargin(margin);

    hlayout14 = new QHBoxLayout();
    hlayout14->setSpacing(spacing);
    hlayout14->setMargin(margin);

    hlayout15 = new QHBoxLayout();
    hlayout15->setSpacing(spacing);
    hlayout15->setMargin(margin);

    labeltonueberschrift = new QLabel(window);
    labeltonueberschrift->setText(tr("Tonqualitaet Einstellungen"));

    // Das Bild Bild uebergeben
    labelbildton = new QLabel(window);
    labelbildton->setPixmap(QPixmap("/usr/share/dvd2xvid/icons/ton.png"));

    // Beschriftung fuer "labelaudio" (Audio Encodierungs Optionen)
    labelaudio = new QLabel(window);
    labelaudio->setText(tr("Encodierungsoptionen:"));

    // Beschriftung fuer "labelbitrateton" (Bitrateton Encodierungs Optionen)
    labelbitrateton = new QLabel(window);
    labelbitrateton->setText(tr("Bitrate Einstellungen:"));

    // Beschriftung fuer "coslang"
    labelalang= new QLabel(window);
    labelalang->setText(tr("1. Audiospur:"));

    // Beschriftung fuer "coslang" 
    labelalang2= new QLabel(window);
    labelalang2->setText(tr("2. Audiospur:"));

    // Beschriftung fuer "countertitel"
    labeluntertitel = new QLabel(window);
    labeluntertitel->setText(tr("Mit welchem Untertitel encodieren:"));

    // Darin wird dann ausgewaehlt wie der Audio bereich decodiert werden soll
    cobaudio = new QComboBox(window);

    // Eintraege fuer "coauido"
    cobaudio->insertItem("copy");

    // Darin wird dann ausgewaehlt welcher Audiospur decodiert werden soll
    coalang= new QComboBox(window);

    // Darin wird dann ausgewaehlt ob und welche zweite Audiospur decodiert werden soll
    coalang2= new QComboBox(window);

    // Darin wird dann ausgewaehlt welcher unterdtitel mit decodiert werden soll
    countertitel = new QComboBox(window);

    // Darin wird dann ausgewaehlt mit welcher Bitrate der Ton konvertiert werden soll
    cobitrateton = new QComboBox(window);
    cobitrateton->setEnabled(false);

    // Eintraege fuer "cobitrate"
    cobitrateton->insertItem("32");
    cobitrateton->insertItem("64");
    cobitrateton->insertItem("96");
    cobitrateton->insertItem("128");
    cobitrateton->insertItem("160");
    cobitrateton->insertItem("192");
    cobitrateton->insertItem("224");
    cobitrateton->insertItem("256");
    cobitrateton->insertItem("288");
    cobitrateton->insertItem("320");
    cobitrateton->insertItem("352");
    cobitrateton->insertItem("384");

    // Abgrenzungslinie zwischen Layout 2 + 3
    linie4 = new QFrame(window);
    linie4->setFrameStyle(QFrame::HLine|QFrame::Plain);
    linie4->setPaletteForegroundColor(Qt::gray);
    linie4->setLineWidth(1);

    // Alle Widgets fuer die Bildauswahl einfuegen
    //Zeile 1
    hlayout11->addWidget(labelbildton,1);
    hlayout11->addWidget(labeltonueberschrift,2);

    // Zeile 2
    hlayout12->addWidget(labelalang,1);
    hlayout12->addWidget(coalang,5);
    hlayout12->addWidget(labelalang2,1);
    hlayout12->addWidget(coalang2,5);


    // Zeile 3
    hlayout13->addWidget(labelaudio,1);
    hlayout13->addWidget(cobaudio,1);
    hlayout13->addWidget(labelbitrateton,1);
    hlayout13->addWidget(cobitrateton,1);

    // Zeile 4
    hlayout14->addWidget(labeluntertitel,1);
    hlayout14->addWidget(countertitel,1);


    //Abgenzungslinie
    hlayout15->addWidget(linie4);

    /************************************/
    /*       Layouts Breich Zeit      */
    /************************************/

    // Die Einzelene Reihen Widgets
    hlayout16 = new QHBoxLayout();
    hlayout16->setSpacing(spacing);
    hlayout16->setMargin(margin);

    hlayout17 = new QHBoxLayout();
    hlayout17->setSpacing(spacing);
    hlayout17->setMargin(margin);

    hlayout18 = new QHBoxLayout();
    hlayout18->setSpacing(spacing);
    hlayout18->setMargin(margin);

    // Das Bild Bild uebergeben
    labelbildzeit = new QLabel(window);
    labelbildzeit->setPixmap(QPixmap("/usr/share/dvd2xvid/icons/zeit.png"));

    // Beschriftung fuer "startzeit"
    labelstartzeit = new QLabel(window);
    labelstartzeit->setText(tr("Beginn bei:"));

    // Beschriftung fuer "endezeit"
    labelendezeit = new QLabel(window);
    labelendezeit->setText(tr("Beende bei:"));

    // Beschriftung fuer Zeit Zeile
    labelzeit = new QLabel(window);
    labelzeit->setText(tr("Zeit Einstellungen"));

    // Beschriftung fuer das Korrektur Feld
    labelKorrektur = new QLabel(window);
    labelKorrektur->setText(tr("Zeitachse verschieben:"));

    // Nur Ganze Zahlen zwischen 0 und 23 zulassen fuer Stunden
    QIntValidator *stundenvalidator = new QIntValidator(0,23,window);

    // Nur Ganze Zahlen zwischen 0 und 59 zulassen fuer minuten und sekunden
    QIntValidator *minutenvalidator = new QIntValidator(0,59,this);

    // Nur Ganze Zahlen zwischen 0 und 59 zulassen fuer minuten und sekunden
    QIntValidator *korrekturValidator = new QIntValidator(-99,99,this);

    korrektur = new QLineEdit(window);
    korrektur->setValidator(korrekturValidator);
    korrektur->setFont(QFont("SansSerif",12));
    korrektur->setMaxLength(3);
    korrektur->setText("00");


    // Erzeugen des Stundenfeldes
    beginstunden = new QLineEdit(window);
    beginstunden->setValidator(stundenvalidator);
    beginstunden->setMaxLength(2);
    beginstunden->setFont(QFont("SansSerif",12));

     // Erzeugen des Minutenfeldes
    beginminuten = new QLineEdit(window);
    beginminuten->setValidator(minutenvalidator);
    beginminuten->setMaxLength(2);
    beginminuten->setFont(QFont("SansSerif",12));

    // Erzeugen des Sekundenfeldes
    beginsekunden = new QLineEdit(window);
    beginsekunden->setValidator(minutenvalidator);
    beginsekunden->setMaxLength(2);
    beginsekunden->setFont(QFont("SansSerif",12));

    // Doppel Punkte dazwischen fuegen
    doppelpunkte1 = new QLabel(":",window);
    doppelpunkte1 ->setFont(QFont("Helvetica",12,QFont::Bold));

    // Zeiter Doppelpunkt dazufuegen
    doppelpunkte2 = new QLabel(":",window);
    doppelpunkte2 ->setFont(QFont("Helvetica",12,QFont::Bold));

    // Erzeugen des Stundenfeldes
    endstunden = new QLineEdit(window);
    endstunden->setValidator(stundenvalidator);
    endstunden->setMaxLength(2);
    endstunden->setFont(QFont("SansSerif",12));

     // Erzeugen des Minutenfeldes
    endminuten = new QLineEdit(window);
    endminuten->setValidator(minutenvalidator);
    endminuten->setMaxLength(2);
    endminuten->setFont(QFont("SansSerif",12));

    // Erzeugen des Sekundenfeldes
    endsekunden = new QLineEdit(window);
    endsekunden->setValidator(minutenvalidator);
    endsekunden->setMaxLength(2);
    endsekunden->setFont(QFont("SansSerif",12));

    // Doppel Punkte dazwischen fuegen
    doppelpunkte3 = new QLabel(":",window);
    doppelpunkte3 ->setFont(QFont("Helvetica",12,QFont::Bold));

    // Zeiter Doppelpunkt dazufuegen
    doppelpunkte4 = new QLabel(":",window);
    doppelpunkte4 ->setFont(QFont("Helvetica",12,QFont::Bold));

    // Standartwert fuer die Zeitfelder zuweisen
    zeitfelder_ruecksetzen();
    korrektur    ->setText("00");

    // Abgrenzungslinie zwischen Layout 2 + 3
    linie5 = new QFrame(window);
    linie5->setFrameStyle(QFrame::HLine|QFrame::Plain);
    linie5->setPaletteForegroundColor(Qt::gray);
    linie5->setLineWidth(1);

    //Zeile 1
    hlayout16->addWidget(labelbildzeit,1);
    hlayout16->addWidget(labelzeit,1);
    hlayout16->addWidget(labelKorrektur,1,Qt::AlignRight);
    hlayout16->addWidget(korrektur,1);

    hlayout17->addWidget(labelstartzeit,1);
    hlayout17->addWidget(beginstunden,20);
    hlayout17->addWidget(doppelpunkte1,1);
    hlayout17->addWidget(beginminuten,20);
    hlayout17->addWidget(doppelpunkte2,1);
    hlayout17->addWidget(beginsekunden,20);
    hlayout17->addWidget(labelendezeit,1);
    hlayout17->addWidget(endstunden,20);
    hlayout17->addWidget(doppelpunkte4,1);
    hlayout17->addWidget(endminuten,20);
    hlayout17->addWidget(doppelpunkte3,1);
    hlayout17->addWidget(endsekunden,20);

    //Abgenzungslinie
    hlayout18->addWidget(linie5);

    /************************************/
    /*       Layouts Breich Start       */
    /************************************/

    // Die Einzelene Reihen Widgets
    hlayout19 = new QHBoxLayout();
    hlayout19->setSpacing(spacing);
    hlayout19->setMargin(margin);

    hlayout20 = new QHBoxLayout();
    hlayout20->setSpacing(spacing);
    hlayout20->setMargin(margin);

    // Beschriftung fuer die start Zeile
    labelstart = new QLabel(window);
    labelstart->setText(tr("Starten oder Hinzufuegen zur Stapelverarbeitung"));

    // Das Bild Bild uebergeben
    labelbildstart = new QLabel(window);
    labelbildstart->setPixmap(QPixmap("/usr/share/dvd2xvid/icons/start.png"));

    // der Codiervorgang soll gestartet werden
    encodiere = new QPushButton(window);
    encodiere->setText(tr("Starten"));
    //encodiere->setPaletteBackgroundColor(Qt::darkGreen);
    //encodiere->setPaletteForegroundColor(Qt::white);

    // Alle Einstellungen speicher
    beenden = new QPushButton(window);
    beenden->setText(tr("Beenden"));

    //Encodiern noch nicht starten und ausgabe String Temporaer speichern
    anhaengen = new QPushButton(window);
    anhaengen->setText(tr("Hinzufuegen"));

    //Zeile 1
    hlayout19->addWidget(labelbildstart,1);
    hlayout19->addWidget(labelstart,4);

    //Zeile2
    hlayout20->addWidget(encodiere,1);
    hlayout20->addWidget(anhaengen,1);
    hlayout20->addWidget(beenden,1);




    /************************************/
    /*    Layouts zusammenfuegen        */
    /************************************/

    // Das Haupt Widget welches die anderen Vertikal ordnet
    vlayout1 = new QVBoxLayout(window);
    vlayout1->setMenuBar(menubar);


    vlayout1->addLayout(hlayout2,1);
    vlayout1->addLayout(hlayout3,1);
    vlayout1->addLayout(hlayout4,1);
    vlayout1->addLayout(hlayout5,1);
    vlayout1->addLayout(hlayout6,1);
    vlayout1->addLayout(hlayout8,1);
    vlayout1->addLayout(hlayout9,1);
    vlayout1->addLayout(hlayout10,1);
    vlayout1->addLayout(hlayout12,1);
    vlayout1->addLayout(hlayout13,1);
    vlayout1->addLayout(hlayout14,1);
    vlayout1->addLayout(hlayout15,1);
    vlayout1->addLayout(hlayout18,1);
    vlayout1->addLayout(hlayout20,1);

    // Bei Layouts ohne Knoepfe sonst falsche Darstellung (Bug in Qt?)
    vlayout1->insertLayout(0,hlayout1);
    vlayout1->insertLayout(6,hlayout7);
    vlayout1->insertLayout(10,hlayout11);
    vlayout1->insertLayout(15,hlayout16);
    vlayout1->insertLayout(16,hlayout17);
    vlayout1->insertLayout(18,hlayout19);


    /************************************/
    /*          Layouts ENDE            */
    /************************************/

    // Diese Klasse enthaelt die Slots fuer das Auslesen der DVD-Infos
    dvd = new DVDReader(cotitel,coalang,coalang2,countertitel,encodieren,debuglevel);

    // Kleine Hilfen die Erscheinen wenn der Mauszeiger darueber verweilt
    QToolTip::setWakeUpDelay(2000);
    QToolTip::setFont(QFont("SansSerif",11));
    QToolTip::add( korrektur,tr("Verschiebt die Anfangs- und/oder Endzeiten\num den eingestellten Sekunden Wert."));
    QToolTip::add( beenden,  tr("Beendet das Programm."));
    QToolTip::add( encodiere,tr("Beginnt mit der Encodierung."));
    QToolTip::add( anhaengen,tr("Fuegt den Auftrag in die Stapelverarbeitung ein."));
    QToolTip::add( vorschau, tr("Startet Mplayer mit den eingestellten Optionen fuer \n Ton-, Untertitel- und Titeleinstellungen."));
    QToolTip::add( mount,    tr("Einbinden und auswaehlen des DVD-Laufwerks.\nBei erneuter Betaetigung loesen der Laufwerkseinbindung."));
    QToolTip::add( cb2pass,  tr("Im 2Pass Modus wird vor dem eigentlichen\nEncodieren ein Analysedurchlauf durchgefuert. \nDies dauert zwar fast doppelt so lange, ergibt\njedoch eine merklich bessere Qualitaet bei\nselber Dateigroesse."));
    QToolTip::add( cbautoaspect,tr("Damit wird das Seitenverhaeltnis automatisch richtig gestellt."));
    QToolTip::add( cbcartoon,   tr("Bessere Encodierung bei Zeichentrick."));
    QToolTip::add( cobvhq,      tr("Der Algorithmus fr die Bewegungsabschtzung basiert auf der Suche im\nFarbraum und versucht, einen Motion-Vector zu finden, der die Differenz\nzwischen dem ursprnglichen und dem encodierten Frame minimiert.\n0= aus (Standard), 1= Entscheidung des Modus (Inter-/Intra-Macro-Block)\n2= begrenzte Suche, 3= mittlere Suche, 4= ausgiebige Suche" ));


    /************************************/
    /*              Events              */
    /************************************/

    // Benenden das Programm
    QObject::connect(beenden,      SIGNAL(released()),                  &app,     SLOT(quit()));
    QObject::connect(encodieren,   SIGNAL(runterfahren()),              &app,     SLOT(quit()));
    QObject::connect(menubar,      SIGNAL(exit()),                      &app,     SLOT(quit()));

     // Der Encodiervorgang ist gestartet worden mache die Fenster unsichtbar
    QObject::connect(encodieren,   SIGNAL(verstecken()),              window,     SLOT(hide()));

    // Beim Druecken von von "Encodieren" soll der decodiervorgang gestartet werden
    QObject::connect(encodiere,    SIGNAL(released()),            encodieren,     SLOT(encodieren()));

    // Mountet einen DVD beim drueken des Knopfes
    QObject::connect(mount,        SIGNAL(released()),                  this,     SLOT(mounten()));

    // Mountet die 2 DVD beim drueken des Knopfes
    QObject::connect(mount2,       SIGNAL(released()),                  this,     SLOT(mount2DVD()));

    // Beim Druecken von von "speichern" sollen alle Einstellungen gespeichert werden
    QObject::connect(menubar,      SIGNAL(speichern()),           encodieren,     SLOT(speichern()));

    // Beim Druecken von von "anhaengen" wird der momentan Auftrag angehaengt
    QObject::connect(anhaengen,    SIGNAL(released()),            encodieren,     SLOT(anhaengen()));

    // Nach den Einbindne der DVD soll die DVD gleich ausgwaehlt werden
    QObject::connect(process_mounten, SIGNAL(processExited()),          this,     SLOT(setindirname()));

    // Wenn etwas beim einlesen der DVD schief geht dann setze die anzeigen zurueck
    QObject::connect(dvd,          SIGNAL(cantOpen()),                   this,    SLOT(mountFault()));

    // Beim Druecken von von "encodieren" soll der decodiervorgang gestartet werden
    QObject::connect(menubar,      SIGNAL(standard()),                   this,    SLOT(ruecksetzen()));

    // Wenn in der Menueleiste die Sprache veraendert wird dann stell sie hier um
    QObject::connect(menubar,      SIGNAL(english()),                     this,   SLOT(setEnglish()));

    // Die Untertiteln mit der 2 Sprache ersetzen und wieder zurueck
    QObject::connect(coalang2,     SIGNAL(activated(const QString&)),     this,   SLOT(zweiteSprache(const QString&)));

    // Wenn in der Menueleiste die Sprache veraendert wird dann stell sie hier um
    QObject::connect(menubar,      SIGNAL(deutsch()),                     this,   SLOT(setDeutsch()));

    // Beim Druecken von von "Vorschau" soll Mplayer mit den Audio- und Untertitel-einstellungen gestartet werden
    QObject::connect(vorschau,     SIGNAL(released()),               encodieren,  SLOT(vorschau()));

    // Der Eingegeben Name wird dem Slot "setoutname" uebergeben 
    QObject::connect(outfile,      SIGNAL(released()),                     this,  SLOT(setOutPfad()));

    // Sagt den Knopf "indir" das wenn er gedrueckt wird der FileDialog geoeffnet werden soll, ueber den Slot "setindirname" 
    QObject::connect(indir,        SIGNAL(released()),               encodieren,  SLOT(setindirname()));

    // Wenn die Checkbox aktiviert wird wird das Siganl an "setcartoon" weietrgegeben
    QObject::connect(cbcartoon,    SIGNAL(toggled(bool)),            encodieren,  SLOT(setcartoon(bool)));

     // Wenn die Checkbox aktiviert wird wird das Siganl an "set2pass" weietrgegeben
    QObject::connect(cb2pass,      SIGNAL(toggled(bool)),            encodieren,  SLOT(set2pass(bool)));

    // Wenn in der ComboBob etwas aktiviert wird wird der Int  an "setvhq" weietrgegeben
    QObject::connect(cobvhq,       SIGNAL(activated(const QString&)),encodieren,  SLOT(setvhq(const QString&)));

    // Wenn die Checkbox aktiviert wird wird das Siganl an "setautoaspect" weietrgegeben
    QObject::connect(cbautoaspect, SIGNAL(toggled(bool)),            encodieren,  SLOT(setautoaspect(bool)));

     // Wenn in der ComboBob etwas aktiviert wird wird der Stringwert  an "setaudioopt" weietrgegeben
    QObject::connect(cobaudio,     SIGNAL(activated(const QString&)), encodieren, SLOT(setauidoopt(const QString&)));

    // Wenn in der ComboBob etwas aktiviert wird, schoen ob man Audiobitrate ein oder aus schalten kann
    QObject::connect(cobaudio,     SIGNAL(activated(const QString&)),       this, SLOT(kontrolleaudiobitrate(const QString&)));

    // Wenn in der ComboBob etwas aktiviert wird wird der Stringwert  an "setbitrateopt" weietrgegeben
    QObject::connect(cobitrate,    SIGNAL(activated(const QString&)), encodieren, SLOT(setbitrateopt(const QString&)));

    // Wenn in der ComboBob etwas aktiviert wird wird der Stringwert  an "setbitrateopt" weietrgegeben
    QObject::connect(cobitrateton, SIGNAL(activated(const QString&)), encodieren, SLOT(setaudiobitrateopt(const QString&)));

    // Wenn in der ComboBob etwas aktiviert wird wird der Stringwert  an "setbitrateopt" weietrgegeben
    QObject::connect(cotitel,      SIGNAL(activated(int)),            encodieren, SLOT(settitel(int)));

    // Wenn in der ComboBob etwas aktiviert wird wird der Stringwert  an "setaudio" weietrgegeben
    QObject::connect(coalang,      SIGNAL(activated(const QString&)), encodieren, SLOT(setaudio(const QString&)));

    // Wenn in der ComboBob etwas aktiviert wird wird der Stringwert  an "setuntertitel" weietrgegeben
    QObject::connect(countertitel, SIGNAL(activated(const QString&)), encodieren, SLOT(setuntertitel(const QString&)));

    // Den Audiotitel Wert aus DVDReader holen lassen und ihn dort an encodieren schicken
    QObject::connect(coalang,      SIGNAL(activated(int)),                   dvd, SLOT(holeasid(int)));

    // Den Audiotitel Wert aus DVDReader holen lassen und ihn dort an encodieren schicken
    QObject::connect(coalang2,     SIGNAL(activated(int)),                   dvd, SLOT(holeasid2(int)));

    // Den Untertitelwert aus DVDReader holen lassen und ihn dort an encodieren schicken
    QObject::connect(countertitel, SIGNAL(activated(int)),                   dvd, SLOT(holessid(int)));

    // Wenn ein neuer Ordner ausgweaehlt wird soll dort nach Titel informationen gesucht werden
    QObject::connect(encodieren,   SIGNAL(ordnerausgewaehlt(QString)),       dvd, SLOT(leseDVD(QString)));

    // Wenn ein titel ausgweaehlt wird sollen neue Audioinformationen eingelesen werden
    QObject::connect(encodieren,   SIGNAL(titelausgewaehlt(int)),            dvd, SLOT(leseAudio(int)));

    // Setzt alle Werte auf Null von den Zeitfeldern
    QObject::connect(encodieren,   SIGNAL(zeitfelderrucksetzen()),          this, SLOT(zeitfelder_ruecksetzen()));

    // Da der Encodiervorgang zu Ende ist loesche das Stapelfenster 
    QObject::connect(encodieren,   SIGNAL(fertig()),                        this, SLOT(fertig()));

    // Die DVD sauber entbinden
    QObject::connect(encodieren,      SIGNAL(umount()),                     this, SLOT(umount()));

    // Das Editierfenster fuer den Encodieraufruf anzeigen
    QObject::connect(encodieren,SIGNAL(aufrufEditieren(const QString&)),editierfenster, SLOT(aufrufEditieren(const QString&)));

    // Wenn der String nur angeaengt wird dann Fuege diese Spaltehinzu
    QObject::connect(encodieren,      SIGNAL(aufruf(QString,QString,bool,bool,bool)),     stapel,
                                      SLOT(addZeile(QString,QString,bool,bool,bool)));

    // Aendert den Text der Ueberschrift vom Stapefenster
    QObject::connect(encodieren,      SIGNAL(aktiveZeile(int,bool,bool)),         stapel,
                                      SLOT(setStartEncodieren(int,bool,bool)));

    // Die DVD sauber entbinden
    QObject::connect(menubar,         SIGNAL(laufwerk(bool)),             this,         SLOT(laufwerk2(bool)));

    // Wenn eines der Drei Felder geandert wird soll der komplette string gesendet werden
    QObject::connect(beginstunden,  SIGNAL(textChanged(const QString&)), this, SLOT(zusammenfuegen_beginzeit(const QString&)));
    QObject::connect(beginminuten,  SIGNAL(textChanged(const QString&)), this, SLOT(zusammenfuegen_beginzeit(const QString&)));
    QObject::connect(beginsekunden, SIGNAL(textChanged(const QString&)), this, SLOT(zusammenfuegen_beginzeit(const QString&)));
    QObject::connect(endstunden,    SIGNAL(textChanged(const QString&)), this, SLOT(zusammenfuegen_endzeit(const QString&)));
    QObject::connect(endminuten,    SIGNAL(textChanged(const QString&)), this, SLOT(zusammenfuegen_endzeit(const QString&)));
    QObject::connect(endsekunden,   SIGNAL(textChanged(const QString&)), this, SLOT(zusammenfuegen_endzeit(const QString&)));

    // Wenn sich der Korrekturwert geaendert hat an encodieren schicken
    QObject::connect(korrektur,     SIGNAL(textChanged(const QString&)), encodieren, SLOT(setkorrektur(const QString&)));

    // Die Einstellungen Sichtbar machen
    anzeigen();

    // Damit man die eventuell vorhandnen Titelinformationen im gespeicherten Indirorner holt
    dvd->leseDVD(encodieren->getindirname());

    // Den Wert fuer "bool2Laufwerk" holen und anzeigen
    laufwerk2(encodieren->get2DVDLaufwerk());

    // Die Schriftgroesse und Schriftart anpassen
    setFont("SansSerif",10);

    // Festlegen der Minimumgroesse des Fensters
    window->setMinimumSize (breite, hoehe);

    // sagt der qtAplication das "window" das Hauptwidget ist
    app.setMainWidget(window);

    // damit das  Hautfenster "window" auch sichtbar wird
    window->show();

    // starte dann das Programm
    app.exec();

}

void Gui::ruecksetzen(void)
{
    // Laesst alle Einstellungen auf den Standartwert setzen
    encodieren->ruecksetzen();
    menubar   ->ruecksetzen();

    korrektur    ->setText("00");

    anzeigen();
}


void Gui::zeitfelder_ruecksetzen(void)
{
    // Standartwert fuer die Zeitfelder zuweisen
    beginstunden ->setText("00");
    beginminuten ->setText("00");
    beginsekunden->setText("00");
    endstunden   ->setText("00");
    endminuten   ->setText("00");
    endsekunden  ->setText("00");
}

void Gui::anzeigen(void)
{
    // Die 2 Audiosprache einmal durchlaufen lassen
    zweiteSprache ("* ");

    // Die Sandart Wert abholen und diese sichtbar machen
    cobitrate   ->setCurrentText(encodieren->getbitrateopt());
    cobitrateton->setCurrentText(encodieren->getaudiobitrateopt());
    cobaudio    ->setCurrentText(encodieren->getaudioopt());
    cobvhq      ->setCurrentText(encodieren->getvhq());

    cbautoaspect->setChecked(encodieren->getautoaspect());
    cb2pass     ->setChecked(encodieren->get2pass());
    cbcartoon   ->setChecked(encodieren->getcartoon());

    // Den Text im "outfile"Button apassen
    outfile->setText(checkoutfilelaenge(encodieren->getoutdirname()));

    // Momentane Sprache auswaehlen
    sprache=encodieren->getsprache();

    // Wenn die Varibale "de" ist dann setze alles auf Deutsch
    if(sprache=="de")
    {
        menubar->setDeutsch();
    }
    else
    {
        // Wenn die Varibale "en" ist dann setze alles auf English
        if(sprache=="en")
        {
            menubar->setEnglish();
        }
    }

    // kontrollieren ob das cobitratton feld aktiviert werden soll
    kontrolleaudiobitrate(cobaudio->currentText());

    // Den Text des erstens Mountbuttons anpassen
    if(bool2Laufwerk==false)
    {
        mount   ->setText("Mount DVD");
    }
    else
    {
        mount  ->setText("Mount DVD 1");
    }
}

void Gui::mounten(void)
{
    // waehrend des mounten beide Mount Knoepfe abschalten
    mount->setEnabled(false);
    mount2->setEnabled(false);

    if (boolmount==false)
    {
        // Fensternahme aendern damit angezeigt wird das gerade gemountet wird
        window->setCaption(name+"                                              * Read - DVD *");

        // Eventuell alte Argumente Loeschen
        process_mounten->clearArguments();

        // Den Mount Befehl als Argumen Uebergeben
        process_mounten->addArgument("mount");

        // Den Ort zum Mounten als Argument Uebergeben
        process_mounten->addArgument(encodieren->getmountpfad());

        // Starten des QProcess , also jetzt wird gemountet
        process_mounten->start();
    }
    else
    {
        // Damit das Laufwerk nicht Bussy ist
        dvd->loeseDVD();

        // Umountet eine Eingelegte DVD
        system(("umount "+encodieren->getmountpfad()));

        // Damit der Befehl auch sichtbar wird
        cout<<endl<<" umount "<<encodieren->getmountpfad()<<endl<<endl;

        // DVD Einstellungen nur zuruecksetzen wenn die DVD noch angewahlt ist
        if(encodieren->getmountpfad()==encodieren->getindirname())
        {
            // Den Indir Ordner wieder nochmal anwaehlen damit die Titelinfarmationen rueckgestzt werden
            encodieren->set_indirname(encodieren->getmountpfad());
        }

        // Den Text vom Mount-Button wider richtig stellen
        mount->setText("Mount DVD 1");


        // Damit der naechste Aufruf die DVD wieder einbindet
        boolmount=false;

        // Nach dem mounten beide Mount Knoepfe wiedereinschalten
        mount->setEnabled(true);
        mount2->setEnabled(true);
    }

}

void Gui::setindirname (void)
{

    // Wieder den richitgen Namen in der Titlelesite anzeiegn
    window->setCaption(name);

    if(bool2mounten==false)
    {
        // Kotrolle ob es einen Fehler gegeben hat
        if(process_mounten->exitStatus()==0)
        {
            if(debuglevel>=3)
            {
                cout<<"gui.cpp: Mounten erfolgreich : "<<process_mounten->exitStatus()<<endl<<endl;
            }
            // Damit der Befehl auch sichtbar wird
            cout<<endl<<" mount "<<encodieren->getmountpfad()<<endl<<endl;

            // damit der naechste Aufruf die DVD wieder ausbindnet
            boolmount=true;

            // Denn DVD Ordner gleich Auswaehlen
            encodieren->set_indirname(encodieren->getmountpfad());

            // Den Text vom Mount-Botton auf unmount setzen
            mount->setText("UMount DVD 1");

        }

        // Kontrolle ob das ein Fehler war weil die DVD schon eingebunden war
        if(process_mounten->exitStatus()==32)
        {
            if(debuglevel>=3)
            {
                cout<<"gui.cpp: Mounten nicht erforderlich : "<<process_mounten->exitStatus()<<endl<<endl;
            }

            // Den Text vom Mount-Botton auf unmount setzen
            mount->setText("UMount DVD 1");


            // damit der naechste Aufruf die DVD wieder ausbindnet
            boolmount=true;

            // Denn DVD Ordner gleich Auswaehlen
            encodieren->set_indirname(encodieren->getmountpfad());

        }
    }
    else
    {
         // Kotrolle ob es einen Fehler gegeben hat
        if(process_mounten->exitStatus()==0)
        {
            if(debuglevel>=3)
            {
                cout<<"gui.cpp: Mounten erfolgreich : "<<process_mounten->exitStatus()<<endl<<endl;
            }

            // Damit der Befehl auch sichtbar wird
            cout<<endl<<" mount "<<encodieren->getmountpfad2()<<endl<<endl;

            // damit der naechste Aufruf die DVD wieder ausbindnet
            boolmount2=true;

            // Denn DVD Ordner gleich Auswaehlen
            encodieren->set_indirname(encodieren->getmountpfad2());

            if(bool2Laufwerk==true)
            {
                // Den Text vom Mount-Botton auf UM 1 setzen
                mount2->setText("UMount DVD 2");
            }
        }

        // Kontrolle ob das ein Fehler war weil die DVD schon eingebunden war
        if(process_mounten->exitStatus()==32)
        {
            if(debuglevel>=3)
            {
                cout<<"gui.cpp: Mounten2 nicht erforderlich : "<<process_mounten->exitStatus()<<endl<<endl;
            }

            if(bool2Laufwerk==true)
            {
                // Den Text vom Mount-Botton auf UM 1 setzen
                mount2->setText("UMount DVD 2");
            }

            // damit der naechste Aufruf die DVD wieder ausbindnet
            boolmount2=true;

            // Denn DVD Ordner gleich Auswaehlen
            encodieren->set_indirname(encodieren->getmountpfad2());
        }
    }

    //bool2mounten wieder auf false damit beim naechsten Aufruf wieder alles auf 0 steht
    bool2mounten=false;

    if(debuglevel>=3)
    {
        cout<<"gui.cpp: Mounten status : "<<process_mounten->exitStatus()<<endl<<endl;
    }

    // Nach dem mounten beide Mount Knoepfe wiedereinschalten
    mount->setEnabled(true);
    mount2->setEnabled(true);

}

void Gui::setOutPfad(void)
{
    if(debuglevel>=2)
    {
        cout<<"gui.cpp: * Slot : setOutPfad *"<<endl<<endl;
    }

    // Erstell den Filedialog
    QFileDialog *outname = new QFileDialog(window);


    // Kontrollieren ob die Datei schon vorhanden ist
    for(int var1=2;var1==2;)
    {
        // Oeffnet einen Dialog in dem man den Ort und den Dateinamen auswaehlen kann
        outdirname=outname->getSaveFileName(encodieren->getoutdirname(),0,window);

        //Kontrollieren ob ein Dateityp im Dateinamen angegebn worden ist
        if(outdirname.find(".",0,true)==-1)
        {
            //Haenge and die Datei noch das avi kuerzel dran
            outdirname+=".avi";
        }

        // Kontrolle ob der Dateinamen schon vorhaneden ist 
        ifstream einlesen(outdirname);

        // Kontrolliert ob die Datei geoeffnet werden konnte
        if(einlesen)
        {
            if(debuglevel==3)
            {
                cout<<"gui.cpp: Datei unter diesen Pfad bereits vorhanden "<<outdirname<<endl<<endl;
            }

            // Meldung ausgeben das die Datei bereits vorhanden ist
            var1=QMessageBox::information(window," INFORMATION!",tr("Die Datei ist bereis vorhanden !\n     berschreiben ?"),
                                QMessageBox::Ok,QMessageBox::Cancel,QMessageBox::NoButton);

        }
        else
        {
            // Wenn die Datei noch nicht vorhanden ist, dann verlasse die Schleife
            var1=1;
        }
    }

    // Den neuen Pfad an encodieren schicken
    encodieren->setoutname(outdirname);

    // Den Text im "outfile"Button apassen
    outfile->setText(checkoutfilelaenge(encodieren->getoutdirname()));
}

QString Gui::checkoutfilelaenge (const QString& uebergabe)
{
    if(debuglevel>=2)
    {
        cout<<"gui.cpp: * Slot : checkoutfilelaenge *"<<endl<<endl;
    }

    // Kontrolliert ob der Dateiname nicht mehr als 45 Zeichen hat ansonsten wird er abgekuerzt
    if(uebergabe.length()<43)
    {
        return uebergabe;
    }
    else
    {
        // Einmal denn String von Rechts auf 43 Zeichen verkuerzen
        temp=uebergabe.right(43);

        // Entfernt die Zeichen bis zum naechsten Ordner Strich
        temp=temp.remove(0,temp.find("/",0,false));

        // Die drei Punkte am Anfang hinzufuegen
        temp="..."+temp;

        return temp;
    }
}

void Gui::mountFault (void)
{
    if(debuglevel>=3)
    {
        cout<<"gui.cpp: Fehler beim einbinden der DVD (GUI) "<<endl<<endl;
    }

    if(bool2Laufwerk==true)
    {
        if(bool2mounten==true)
        {
            // Den Text vom Mount-Button wider richtig stellen
            mount2->setText("Mount DVD 2");
        }
        else
        {
            // Den Text vom Mount-Button wider richtig stellen
            mount->setText("Mount DVD 1");
        }
    }
    else
    {
        // Den Text vom Mount-Button wider richtig stellen
        mount->setText("Mount DVD");
    }

    if(bool2mounten==true)
    {
        // Damit der naechste Aufruf die DVD wieder einbinden versucht
        boolmount2=false;
    }
    else
    {
        boolmount =false;
    }

    //bool2mounten wieder auf false damit beim naechsten Aufruf wieder alles auf 0 steht
    bool2mounten=false;

    // Nach dem mounten beide Mount Knoepfe wiedereinschalten
    mount->setEnabled(true);
    mount2->setEnabled(true);
}

void Gui::umount (void)
{
    // Slot DVD mount nur aufrufen wenn die DVD bereits eingebunden ist
    if(boolmount==true)
    {
        mounten();
    }

    if(boolmount2==true)
    {
        mount2DVD();
    }
}

void Gui::positionieren (void)
{
    QDesktopWidget *Desktop =  qApp->desktop();

    //Auf welchen Desktop laeuft das Programm? 
    int Schirmnummer=Desktop->screenNumber(window);

    //wie gross ist dieser? 
    QRect Bildschirmgroesse=Desktop->availableGeometry(Schirmnummer);

    //neue x Position ergibnt sich aus Bildschirmgroesse-Programmgroesse/2
    poshor=((Bildschirmgroesse.width()/2)-(breite/2));

    posver=30;

    // legt die Groesse des Fensters und die Position am Bildschirm fest
    window->setGeometry(poshor,posver,breite,hoehe);
}

void Gui::setDeutsch(void)
{
    if(debuglevel>=2)
    {
        cout<<"gui.cpp: * Slot : setDetsch (Gui)*"<<endl<<endl;
    }

    // Sprache abspeichern
    sprache="de";

    // Menueleiste auch auf English setzen
    menubar->setDeutsch();

    // Sprache an encodieren senden (fuer Einstellunegn)
    encodieren->setsprache(sprache);

    // Meldung ausgeben das Sie Sprache erst nach einem Neustart umgestellt wird
    QMessageBox::information(window," INFORMATION!","Die Sprache wird erst nach einem Neustart umgestellt.",
                             QMessageBox::Ok,QMessageBox::NoButton,QMessageBox::NoButton);
}

void Gui::setEnglish(void)
{
    if(debuglevel>=2)
    {
        cout<<"gui.cpp: * Slot : setEnglish (Gui)*"<<endl<<endl;
    }

    // Sprache abspeichern
    sprache="en";

    // Menueleiste auch auf English setzen
    menubar->setEnglish();

    // Sprache an encodieren senden (fuer Einstellunegn)
    encodieren->setsprache(sprache);

    QMessageBox::information(window," INFORMATION!","The language will be changed after restart.",
                             QMessageBox::Ok,QMessageBox::NoButton,QMessageBox::NoButton);
}

void Gui::fertig (void)
{
    // Damit die Ueberschirft wieder richtig dagestellt wird
    stapel->resetLabel();

    // alles im Stapelfenster zurueck setzen
    stapel->reset();

    //Das Hauptfenster wieder sichtbar machen
    window->show();
}

void Gui::setFont (QString schriftart,int groesse)
{
    outfile->setFont(QFont(schriftart,groesse));
    indir->setFont(QFont(schriftart,groesse));
    encodiere->setFont(QFont(schriftart,groesse));
    beenden->setFont(QFont(schriftart,groesse));
    vorschau->setFont(QFont(schriftart,groesse));
    anhaengen->setFont(QFont(schriftart,groesse));
    mount->setFont(QFont(schriftart,groesse));
    mount2->setFont(QFont(schriftart,groesse));
    cobaudio->setFont(QFont(schriftart,groesse));
    cobvhq->setFont(QFont(schriftart,groesse));
    cobitrate->setFont(QFont(schriftart,groesse));
    countertitel->setFont(QFont(schriftart,groesse));
    coalang->setFont(QFont(schriftart,groesse));
    cotitel->setFont(QFont(schriftart,groesse));
    labelindirname->setFont(QFont(schriftart,groesse));
    labeloutname->setFont(QFont(schriftart,groesse));
    labelcartoon->setFont(QFont(schriftart,groesse));
    label2pass->setFont(QFont(schriftart,groesse));
    labelautoaspect->setFont(QFont(schriftart,groesse));
    labelvhq->setFont(QFont(schriftart,groesse));
    labelaudio->setFont(QFont(schriftart,groesse));
    labelbitrate->setFont(QFont(schriftart,groesse));
    labeltitle->setFont(QFont(schriftart,groesse));
    labelalang->setFont(QFont(schriftart,groesse));
    labelalang2->setFont(QFont(schriftart,groesse));
    labeluntertitel->setFont(QFont(schriftart,groesse));
    labelstartzeit->setFont(QFont(schriftart,groesse));
    labelendezeit->setFont(QFont(schriftart,groesse));
    labelbildueberschrift->setFont(QFont(schriftart,groesse));
    labelbitrateton->setFont(QFont(schriftart,groesse));
    labelKorrektur->setFont(QFont(schriftart,groesse));

    // Ueberschriften
    labelindirname->setFont(QFont(schriftart,groesse));
    labeltonueberschrift->setFont(QFont(schriftart,groesse));
    labelzeit->setFont(QFont(schriftart,groesse));
    labelbildueberschrift->setFont(QFont(schriftart,groesse));
    labelstart->setFont(QFont(schriftart,groesse));
}

void Gui::laufwerk2 (bool aktiv)
{
    if(debuglevel>=2)
    {
        cout<<"gui.cpp: * Slot : laufwerk2 (Gui) *"<<endl<<endl;
    }

    // Einmal den Wert von "aktiv" abspeichern
    bool2Laufwerk=aktiv;

    // Kontollieren ob der das zweite Laufwerk aktive ist
    if(bool2Laufwerk==true)
    {
         // Den Text des ersten Knopfes richtig stellen
        mount ->setText("Mount DVD 1");

        // Den Knopf fuer das zweite Laufwerk sichtbar machen
        mount2->show();
    }
    else
    {
        // Den Knopf fuer das zweite Laufwerk ausblenden
        mount2->hide();

        // Den Text des ersten Knopfes richtig stellen
        mount ->setText("Mount DVD");
    }

}

void Gui::mount2DVD (void)
{
    if(debuglevel>=2)
    {
        cout<<"gui.cpp: * Slot : mount2DVD (Gui) *"<<endl<<endl;
    }

    // waehrend des mounten beide Mount Knoepfe abschalten
    mount->setEnabled(false);
    mount2->setEnabled(false);

    // Damit die 2 DVD gemountet wird bei "mounten"
    bool2mounten=true;

    if (boolmount2==false)
    {
        // Fensternahme aendern damit angezeigt wird das gerade gemountet wird
        window->setCaption(name+"                                              * Read - DVD *");

        // Eventuell alte Argumente Loeschen
        process_mounten->clearArguments();

        // Den Mount Befehl als Argumen Uebergeben
        process_mounten->addArgument("mount");

        // Den Ort zum Mounten als Argument Uebergeben
        process_mounten->addArgument(encodieren->getmountpfad2());

        // Starten des QProcess , also jetzt wird gemountet
        process_mounten->start();
    }
    else
    {
        // Damit das Laufwerk nicht Bussy ist
        dvd->loeseDVD();

        // Umountet eine Eingelegte DVD
        system(("umount "+encodieren->getmountpfad2()));

        // Damit der Befehl auch sichtbar wird
        cout<<endl<<" umount "<<encodieren->getmountpfad2()<<endl<<endl;

        // DVD Einstellungen nur zuruecksetzen wenn die DVD noch angewahlt ist
        if(encodieren->getmountpfad2()==encodieren->getindirname())
        {
            // Den Indir Ordner wieder nochmal anwaehlen damit die Titelinfarmationen rueckgestzt werden
            encodieren->set_indirname(encodieren->getmountpfad2());
        }

        if(bool2Laufwerk==true)
        {
            // Den Text vom Mount-Button wider richtig stellen
            mount2->setText("Mount DVD 2");
        }

        // Damit der naechste Aufruf die DVD wieder einbindet
        boolmount2=false;

        // Nach dem mounten beide Mount Knoepfe wiedereinschalten
        mount ->setEnabled(true);
        mount2->setEnabled(true);
    }
}

void Gui::zweiteSprache (const QString& zweitesprache)
{
    if(debuglevel>=2)
    {
        cout<<"gui.cpp: * Slot : zweiteSprache (Gui) *"<<endl<<endl;
    }


    // Wenn die Untertieteln wieder zurueckgestellt werden sollen
    if(zweitesprache.left(1)=="*")
    {

        if(bool2Spracheaktive==false)
        {
            // Die zuvor geloeschten Optionen wieder einfuegen
            cobaudio->insertItem("mp3lame");
            cobaudio->insertItem("pcm");
            cobaudio->insertItem("faac");
            //cobaudio->insertItem("lavc");
        }

        // Diverse Elemente wieder Sichtbar machen
        endstunden->setEnabled(true);
        endminuten->setEnabled(true);
        endsekunden->setEnabled(true);
        beginstunden->setEnabled(true);
        beginminuten->setEnabled(true);
        beginsekunden->setEnabled(true);
        korrektur->setEnabled(true);

        // Sich Merken das keine 2 Audiospur giebt
        bool2Spracheaktive=true;

        // Die zweite Audiospur nicht mehr encodierne lassen
        encodieren->set2Audiotrack(false);
    }
    // Oder auf zweite Audiopur stellen
    else
    {

        if(bool2Spracheaktive==true)
        {
            // Die Audiooptionen in dieser Betriebsart aus der Liste loeschen
            cobaudio->setCurrentItem(0);
            cobaudio->clear();
            cobaudio->insertItem("copy");

            // Die Audiocodec Option zuruecksetzen
            encodieren->setauidoopt("copy");

            // Diverse Elemente nicht mehr anwaehlbar machen (nicht kompatiebel mit 2 Audiospuren)
            cobitrateton->setEnabled(false);
            endstunden->setEnabled(false);
            endminuten->setEnabled(false);
            endsekunden->setEnabled(false);
            beginstunden->setEnabled(false);
            beginminuten->setEnabled(false);
            beginsekunden->setEnabled(false);
            korrektur->setEnabled(false);

            // Und die Zeitfelder ruecksetzten
            zeitfelder_ruecksetzen();
        }

        // Sich Merken das es eine 2 Audiospur giebt
        bool2Spracheaktive=false;

        // Die zweite Audiospur in "encodieren" bearbeiten lassen
        encodieren->set2Audiotrack(true);
    }
}

QString Gui::kontrolle(const QString& uebergabe)
{
    // Temporaere Variable fuer die Kontolle, entspricht der Basis des Zahlensystems
    int temp=10;

    // Einmal den Anfangswert ubernehmen
    rueckgabe=uebergabe;

    if(debuglevel>=2)
    {
        cout<<"gui.cpp: * Slot : kontrolle *"<<endl<<endl;
    }

    // Kontrolle der Stunden Zahl
    pruefen=rueckgabe.left(2);

    // Kontrollieren ob das erste Feld Leer ist
    leerkontrolle=pruefen.at(0);

    if(":"==leerkontrolle)
    {
        rueckgabe.insert(0,"00");
    }
    else
    {
        // Nur Kontrolle ob es moeglich waere die Zahl umzuwandeln, wird aber nicht richtig umgewandelt
        pruefen.toInt(&boolkontrolle,temp);

        // Wenn noetig entferne das entsprechende Zeichen
        if(boolkontrolle==false)
        {
            rueckgabe.insert(0,"0");
        }
    }

    if(debuglevel>=3)
    {
        cout<<"gui.cpp: Stundenkontrolle  = "<<pruefen<<" + boolkontrolle = "<<boolkontrolle<<endl;
    }

    // Kontrolle der sekunden Zahl
    pruefen=rueckgabe.mid(2,2);



    if("::"==pruefen)
    {
        rueckgabe.insert(3,"00");
    }
    else
    {
        // Kontrolle der sekunden Zahl
        pruefen=rueckgabe.mid(3,2);

        // Kontrollieren ob das letzte Feld Leer ist
        leerkontrolle=pruefen.at(1);

        if(":"==leerkontrolle)
        {
            rueckgabe.insert(3,"0");
        }
    }

     if(debuglevel>=3)
    {
        cout<<"gui.cpp: Minutenkontrolle  = "<<pruefen<<" + boolkontrolle = "<<boolkontrolle<<endl;
    }

    // Kontrolle der sekunden Zahl
    pruefen=rueckgabe.right(2);

    // Kontrollieren ob das letzte Feld Leer ist
    leerkontrolle=pruefen.at(pruefen.length()-1);

    if(":"==leerkontrolle)
    {
        rueckgabe.insert(rueckgabe.length(),"00");
    }
    else
    {
        // Nur Kontrolle ob es moeglich waere die Zahl umzuwandeln, wird aber nicht wirklich umgewandelt
        pruefen.toInt(&boolkontrolle,temp);

        // Wenn noetig entferne das entsprechende Zeichen
        if(boolkontrolle==false)
        {
            rueckgabe.insert((rueckgabe.length()-1),"0");
        }
    }
    if(debuglevel>=3)
    {
        cout<<"gui.cpp: Sekundenkontrolle = "<<pruefen<<" + boolkontrolle = "<<boolkontrolle<<endl<<endl;
    }

    return rueckgabe;

}


void Gui::zusammenfuegen_beginzeit(const QString&)
{
    if(debuglevel>=2)
    {
        cout<<"gui.cpp: * Slot : zusammenfuegen_beginzeit *"<<endl<<endl;
    }

    // Holt sich den Inhalt aller drei Felder und fuegt ihn zusammen 
    begindreifelder=beginstunden->text()+":"+beginminuten->text()+":"+beginsekunden->text();

    if(debuglevel>=3)
    {
        cout<<"gui.cpp: Vor Kontrolle begindreifelder = "<<begindreifelder<<endl<<endl;
    }

    // Sendet das Signal mit den zusammen gebauten Feldern Stunden:Minuten:sekunten
    encodieren->setstartzeit(kontrolle(begindreifelder));
}

void Gui::zusammenfuegen_endzeit(const QString&)
{
    if(debuglevel>=2)
    {
        cout<<"gui.cpp: * Slot : zusammenfuegen_endzeit *"<<endl<<endl;
    }

    // Holt sich den Inhalt aller drei Felder und fuegt ihn zusammen 
    enddreifelder=endstunden->text()  +":"+endminuten->text()  +":"+endsekunden->text();


    if(debuglevel>=3)
    {
        cout<<"gui.cpp: Vor Kontrolle enddreifelder = "<<enddreifelder<<endl<<endl;
    }

    // Sendet das Signal mit den zusammen gebauten Feldern Stunden:Minuten:sekunten
    encodieren->setendzeit(kontrolle(enddreifelder));
}


void Gui::kontrolleaudiobitrate (const QString& uebergabe)
{
    if(debuglevel>=2)
    {
        cout<<"gui.cpp: * Slot : kotrolleaudiobitrate *"<<endl<<endl;
    }

    if(debuglevel>=3)
    {
        cout<<"gui.cpp: kotrolleaudiobitrate uebergabe = "<<uebergabe<<endl<<endl;
    }

    // Das Audiobitratefeld nur bei richtiger Audiokopieroption aktivieren
    if(uebergabe=="mp3lame"||uebergabe=="faac")
    {
        cobitrateton->setEnabled(true);
    }
    else
    {
        cobitrateton->setEnabled(false);
    }
}

# endif
