/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# ifndef GUI_H
# define GUI_H

# ifndef __STDC_LIMIT_MACROS
# define __STDC_LIMIT_MACROS
# endif

# include <string>
# include <iostream>

# include <qapplication.h>
# include <qlabel.h>
# include <qpushbutton.h>
# include <qcheckbox.h>
# include <qcombobox.h>
# include <qpixmap.h>
# include <qtooltip.h>
# include <qframe.h>
# include <qprocess.h>
# include <qstring.h>
# include <qmessagebox.h>
# include <qrect.h>
# include <qdesktopwidget.h>
# include <qlayout.h>
# include <qlineedit.h>
# include <qvalidator.h>
# include <qtranslator.h>



# include "Encodieren.h"
# include "Menuebar.h"
# include "DVDReader.h"
# include "Stapelfenster.h"
# include "Editierfenster.h"

class Gui : public QObject
{
    Q_OBJECT
    private:

        QString begindreifelder,                 // Alle drei Felder in einem QString
                enddreifelder,                   // Alle drei Felder in einem QString
                pruefen,                         // Darin werden die 3 Zeitfelder Ueberpruft ob ihr Syntax stimmt
                leerkontrolle,                   // Temporaere Ablage fuer die Leerkontrolle
                rueckgabe,                       // Rueckgabevariabel fuer die Zeitfelder
                outdirname;                      // Den Ausgabepfad fuer die Fertige Datei

        QPushButton *encodiere,
                    *outfile,
                    *indir,
                    *beenden,
                    *vorschau,
                    *anhaengen,
                    *mount,
                    *mount2;


        QComboBox  *cobitrate,
                   *cobitrateton,
                   *cobaudio,
                   *cotitel,
                   *coalang,
                   *coalang2,
                   *countertitel,
                   *cobvhq;

        QCheckBox  *cbcartoon,
                   *cb2pass,
                   *cbautoaspect;

        QLabel *labelindirname,
               *labeloutname,
               *labelcartoon,
               *label2pass,
               *labelautoaspect,
               *labelaudio,
               *labelbitrate,
               *labelbildueberschrift,
               *labeltonueberschrift,
               *labelbitrateton,
               *labeltitle,
               *labelalang,
               *labelalang2,
               *labeluntertitel,
               *labelstartzeit,
               *labelendezeit,
               *labelvhq,
               *labelzeit,
               *labelstart,
               *labelbilddvd,
               *labelbildbild,
               *labelbildton,
               *labelbildzeit,
               *labelbildplay,
               *labelbildstart,
               *labelKorrektur,                 // Der Text fuer labelkorrektur
               *doppelpunkte1,                  // Doppel Punkte dazwischen fuegen
               *doppelpunkte2,                  // Doppel Punkte dazwischen fuegen
               *doppelpunkte3,                  // Doppel Punkte dazwischen fuegen
               *doppelpunkte4;                  // Doppel Punkte dazwischen fuegen


        QBoxLayout *hlayout1,
                   *hlayout2,
                   *hlayout3,
                   *hlayout4,
                   *hlayout5,
                   *hlayout6,
                   *hlayout7,
                   *hlayout8,
                   *hlayout9,
                   *hlayout10,
                   *hlayout11,
                   *hlayout12,
                   *hlayout13,
                   *hlayout14,
                   *hlayout15,
                   *hlayout16,
                   *hlayout17,
                   *hlayout18,
                   *hlayout19,
                   *hlayout20,
                   *vlayout1;

        QLineEdit *beginstunden,                     // Beginnzeit Stundenfeld
                  *beginminuten,                     // BeginnzeitMinutenfeld
                  *beginsekunden,                    // BeginnzeitSekundenfeld
                  *endstunden,                     // Endzeit Stundenfeld
                  *endminuten,                     // Endzeit Minutenfeld
                  *endsekunden,                    // EndzeitSekundenfeld
                  *korrektur;                    // Korrekturfeld in Sekunden


        QFrame *linie1,
               *linie2,
               *linie3,
               *linie4,
               *linie5;

        Encodieren *encodieren;

        Menuebar   *menubar;

        Stapelfenster *stapel;

        QWidget    *window;

        DVDReader *dvd;                          // Mit diesen Objekt werden die DVD-Daten gelesen

        Editierfenster *editierfenster;          // In diesen Fenster wird dann der editieraufruf angepasst

        QProcess *process_mounten;

        QTranslator translator;                 // fuer die Sprach auswahl


        bool boolmount,                          // damit sich das Programm merkt was es bei mount DVD tun soll
             boolmount2,                         // Das selbe wie boolmount, aber fuer das zweite Laufwerk
             bool2Laufwerk,                      // Ob das 2 Laufwerk aktivirt ist
             bool2mounten,                       // Ob die 2 DVD gemountet werden soll
             boolkontrolle,                      // Damit wir Kontrolliert ob alle drei Felder richtig sind
             bool2Spracheaktive;                 // Ablegen ob die 2 Sprache aktive ist


        QString temp,                            // Temporaere Ablage von QString Objekten, fuer mounten
                mountpfad,                       // Beinhaltet den Mount-Point fuer die DVD
                sprache,                         // Welche Sprache eingestellt ist
                name;                            // Der name der in der Titelleiste angezeigt werden soll

        short poshor,                            // fuer die Horizontale Position des Fensters
              posver,                            // fuer die Vertikale   Position des Fensters
              breite,                            // fuer die Breite des Fensters
              hoehe,                             // fuer die Hoehe des Fensters
              zeile,                             // fuer die Vertikale   Position des Labels
              spalte_1,                          // fuer die  1 Horizontale Position des Labels
              spalte_2;                          // fuer die  2 Horizontale Position des Labels


        int debuglevel;                          // Der Debuglevle entscheidet wie viel Debuginformationen angezeigt werden

    public:
        Gui(int startdebuglevel,short versionsnummer,QString versionsname);  // Konstruktor


    public slots:
        // Setzt alle veraendert Varibalen zurueck
        void ruecksetzen(void);

        // Hollt die Varibalen aus Einstellengn ueber Decodierne und setzt sie bei denn einzelne Widgets
        void anzeigen (void);

        // mountet eine Eingelegte DVD
        void mounten (void);

        // Indirsetzen nach dem mounten der 1 DVD setzen
        void setindirname (void);

        // Einen neunen Ausgabepfad waehlen
        void setOutPfad(void);

        // Wenn das oeffen der DVD fehlschlaeg, (anzeigen aktaulisieren)
        void mountFault (void);

        // Stelt das Fenster rechts ins rechte obere Eck
        void positionieren (void);

        // Die Sprache auf Deutsch setzen
        void setDeutsch(void);

        // Die Sprache auf English setzen
        void setEnglish(void);

        // Alle Aufgaben die erfuellt werden muessen wen ein Encodier Vorgang fertig ist
        void fertig (void);

        // Die Schriftart und Schriftgroesse aenderen
        void setFont (QString schriftart,int groesse);

        // Eine eventuell eingelegte DVD sicher entbinden
        void umount (void);

        // Mount Knopf auf 2 Laufwerke stellen
        void laufwerk2 (bool aktiv);

        // Die DVD aus dem 2 Laufwerk einbinden
        void mount2DVD (void);

        // Die Untertiteln mit der 2 Sprache ersetzen
        void zweiteSprache (const QString& zweitesprache);

        //Verarbeitet die drei ZeitFelder zusammen und sendet das Siganl "zeitgeaendert"
        void zusammenfuegen_beginzeit(const QString&);
        void zusammenfuegen_endzeit  (const QString&);

        // Kontrolliert die Werte der Zeichenkette
        QString kontrolle (const QString& uebergabe);

        // Alle Zeitwerte Ruecksetzen
        void zeitfelder_ruecksetzen(void);

        // Das Audiobitratefeld nur bei richtiger Audiokopieroption aktivieren
        void kontrolleaudiobitrate (const QString& uebergabe);

        // Kontrolliert ob der Dateiname nicht mehr als 45 Zeichen hat ansonsten wird er abgekuerzt
        QString checkoutfilelaenge (const QString& uebergabe);
};

# endif
