/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# include "Menuebar.h"

# ifndef MENUEBAR_CPP
# define MENUEBAR_CPP

Menuebar::Menuebar (QWidget *parent,Encodieren *uebergabe,int startdebug) : QMenuBar(parent)
{
    // Speichert das Eltern Widget ab
    eltern=parent;

    // Debuglevel setzen
    debuglevel=startdebug;

    if(debuglevel>=2)
    {
        cout<<"Menubar.cpp   : * Konstructor : Menubar "<<endl<<endl;
    }

    // Speichert das Encodieren Objekt in der entsprechende Variable ab
    encodieren=uebergabe;

     /* ---------------------------------*/
     /*      Mountpfad Dialog Menue      */
     /* ---------------------------------*/

    // Erstellt das Dialogfenster fuer den Mountpfad der DVD
    mountpfad = new QDialog(this);
    mountpfad->setGeometry(20,50,360,220);

    // Zeile 1 im Dialogfeld anlegen
    zeile1 = new QLabel(mountpfad);
    zeile1->setGeometry(10,10,340,25);

    // Zeile 2 im Dialogfeld anlegenEinstellungs-Menue
    zeile2 = new QLabel(mountpfad);
    zeile2->setGeometry(10,110,340,25);

    // Eingabe des Mountpfads der ersten DVD
    eingabe1 = new QLineEdit(mountpfad);
    eingabe1->setGeometry(10,40,340,25);

    // Eingabe des Mountpfads der ersten DVD
    eingabe2 = new QLineEdit(mountpfad);
    eingabe2->setGeometry(10,140,340,25);

    // Checkbox ob ein zweites Laufwerk aktiviert werden soll
    cblaufwerk = new QCheckBox(mountpfad);
    cblaufwerk->setGeometry(10,75,340,25);
    cblaufwerk->setChecked(encodieren->get2DVDLaufwerk());

    // "OK" Knopf fuer den Mountpfad Dialog
    ok = new QPushButton(mountpfad);
    ok->setGeometry(265,185,86,25);

    // "Abbrechen" Knopf fuer Mountdialog
    abbrechen = new QPushButton(mountpfad);
    abbrechen->setGeometry(10,185,86,25);

    // Abgrenzungslinie vor der zweiten DVD-Zeile
    QFrame *hlinie1 = new QFrame(mountpfad);
    hlinie1->setPaletteForegroundColor(Qt::lightGray);
    hlinie1->setFrameStyle(QFrame::HLine|QFrame::Plain);
    hlinie1->setLineWidth(1);
    hlinie1->setGeometry(5,105,350,1);

    // Abgrenzungslinie vor der zweiten DVD-Zeile
    QFrame *hlinie2 = new QFrame(mountpfad);
    hlinie2->setPaletteForegroundColor(Qt::lightGray);
    hlinie2->setFrameStyle(QFrame::HLine|QFrame::Plain);
    hlinie2->setLineWidth(1);
    hlinie2->setGeometry(5,175,350,1);


     /* ---------------------------------*/
     /*        Einstellungs-Menue        */
     /* ---------------------------------*/

    // Erstellt das Sprachen Menue
    sprache = new QPopupMenu(this);

    //Das Sprachenmenu mit Inhalt fuellen
    sprache->insertItem("Deutsch",0);
    sprache->insertItem("English",1);

    // Erstellt das Datei Menues
    datei = new QPopupMenu(this);

    // Das Dateimenu mit Inhalten fuellen
    datei-> insertItem(QPixmap("/usr/share/dvd2xvid/icons/reload.png"),tr("Standard") ,1);
    datei-> insertItem(QPixmap("/usr/share/dvd2xvid/icons/filesave.png"),tr("Speichern"),2);
    datei-> insertSeparator();
    datei-> insertItem(QPixmap("/usr/share/dvd2xvid/icons/configure.png"),tr("Mountpfad"),3);
    datei-> insertItem(QPixmap("/usr/share/dvd2xvid/icons/sprachen.png"),tr("Sprache"),sprache,4);
    datei-> insertSeparator();
    datei-> insertItem(QPixmap("/usr/share/dvd2xvid/icons/exit.png"),tr("Beenden"),5);

    // Erstellt das Einstellungs Menue
    einstellungen = new QPopupMenu(this);

    // Mit optionen fuellen
    einstellungen-> insertItem(tr("Ausgabe editieren"),0);
    einstellungen-> insertItem(tr("Encodiermeldungen"),1);
    einstellungen-> insertItem(tr("Protokoll erstellen"),2);

    // Wenn ja dann mach das sichtbar
    einstellungen->setItemChecked(0,encodieren->geteditieren());

    //Gespeicherte Werte abholen
    einstellungen->setItemChecked(1,encodieren->getausgeben());

    //Gespeicherte Werte abholen
    einstellungen->setItemChecked(2,encodieren->getLoger());

     /* ---------------------------------*/
     /*          Option Menue            */
     /* ---------------------------------*/

    // Erstellt das Shutdown Menue
    optionen = new QPopupMenu(this);

    //Das Shutdownmenu mit Inhalt fuellen
    optionen->insertItem(tr("DVD danach loesen"),0);
    optionen->insertItem(tr("DVD danach auswerfen"),1);
    optionen->insertSeparator();
    optionen->insertItem(tr("Dateien zusammenfuegen"),2);
    optionen->insertItem(tr(".part Dateien loeschen"),3);


    // Die PopMeunes werden der Menuebar zugewiesen
    insertItem(tr("Datei"),datei,0);
    insertItem(tr("Expert"),einstellungen,1);
    insertItem(tr("Optionen"),optionen,2);

    // Gespeicherte Werte abholen
    optionen->setItemChecked(0,encodieren->getunmount());

    // Wenn unmounten auf true steht dann kontrolliere auch eject
    if (optionen->isItemChecked(0))
    {
        // Wenn ja dann setzt das Item auf true
        optionen->setItemChecked(1,encodieren->geteject());
    }
    else
    {
        // Wenn nicht dann mach es nicht anwaehlbar
        optionen->setItemEnabled(1,false);
    }

    //Gespeicherte Werte abholen
    optionen->setItemChecked(2,encodieren->getzusammenfuegen());

    // Wenn unmounten auf true steht dann kontrollier auch eject
    if (optionen->isItemChecked(2))
    {
        // Wenn ja dann setzt das Item auf true
        optionen->setItemChecked(3,encodieren->getpart());
    }
    else
    {
        // Wenn nicht dann mach es nicht anwaehlbar
        optionen->setItemEnabled(3,false);
    }

    /*              Events              */

    connect(datei            ,SIGNAL(activated(int))    ,this    ,SLOT(slot_datei(int)));
    connect(einstellungen    ,SIGNAL(activated(int))    ,this    ,SLOT(slot_einstellungen(int)));
    connect(sprache          ,SIGNAL(activated(int))    ,this    ,SLOT(slot_sprachen(int)));
    connect(optionen         ,SIGNAL(activated(int))    ,this    ,SLOT(slot_optionen(int)));

    // Wenn sich der Status des zweiten laufwerks aktiviert oder deaktiviert hat
    connect(cblaufwerk       ,SIGNAL(toggled(bool))     ,this    ,SLOT(set2Laufwerk(bool)));

    // Wenn der "Ok" Knopf gedrueckt wurde dann schliesse das Fenster und gebe die Daten weiter
    connect(ok               ,SIGNAL(released())        ,this    ,SLOT(okgedreuckt()));

    // Wenn der "Abbrechen" Knopf gedrueckt wurde dann schliesse das Fenster und verwerfe die Daten
    connect(abbrechen        ,SIGNAL(released())        ,this    ,SLOT(abbrechengedreuckt()));
}

void Menuebar::slot_datei(int  auswahl)
{
    if(debuglevel>=2)
    {
        cout<<"Menubar.cpp   : * Slot : slot_datei *"<<endl<<endl;
    }

    // Sendet das Signale wenn ein Eintrag ausgewaehlt wird
    if (auswahl==1)
    {
        emit standard();
    }

    if (auswahl==2)
    {
        emit speichern();
    }

    if(auswahl==3)
    {
        bool ok;

        // Den Mountpfad Dialog starten
        mountPfadDialog();

        if(ok==true)
        {
            encodieren->setmountpfad(temp);
        }
    }

    // auwahl 4 = Sprachen siehe slot_sprachen 

    if(auswahl==5)
    {
        emit exit();
    }

}

void Menuebar::slot_einstellungen(int auswahl)
{
    if(debuglevel>=2)
    {
        cout<<"Menubar.cpp   : * Slot : slot_einstellungen *"<<endl<<endl;
    }

    // Damit man sieht welche Punkte aktive sind
    if(einstellungen->isItemChecked(auswahl))
    {
        einstellungen->setItemChecked(auswahl,false);
    }
    else
    {
        einstellungen->setItemChecked(auswahl,true);
    }

    // Ob dei Kommandozeile vor den ausfueren editiert werden soll
    if(auswahl==0)
    {
        encodieren->setedit(einstellungen->isItemChecked(auswahl));
    }


    // Ob die Encodiermeldungen auf der Standart ausgabe angezeit werden sollen
    if(auswahl==1)
    {
        encodieren->setausgeben(einstellungen->isItemChecked(auswahl));
    }

    // Ob der Loger eingeschaltet werden soll
    if(auswahl==2)
    {
        encodieren->setLoger(einstellungen->isItemChecked(auswahl));
    }
}


void Menuebar::slot_optionen(int auswahl)
{
    if(debuglevel>=2)
    {
        cout<<"Menubar.cpp   : * Slot : slot_optionen *"<<endl<<endl;
    }

    // damit man sieht welche Punkte aktive sind
    if(optionen->isItemChecked(auswahl))
    {
        optionen->setItemChecked(auswahl,false);
    }
    else
    {
        optionen->setItemChecked(auswahl,true);
    }

    // Wenn unmounten aktiviert wird erst dann soll man auch oeffnen aktivieren koennen
    if(auswahl==0)
    {
        // Kontrolle ob dieses Item schon sichtbar ist
        if (optionen->isItemChecked(0))
        {
            // wenn nein dann mach es sichtbar
            optionen->setItemEnabled(1,true);
        }
        else
        {
            //  wenn ja dann mach es wieder unsichtbar 
            optionen->setItemEnabled(1,false);
            optionen->setItemChecked(1,false);
            encodieren->setbooleject(false);
        }
    }

    // Wenn unmounten aktiviert wird erst dann soll man auch oeffnen aktivieren koennen
    if(auswahl==2)
    {
        // Kontrolle ob dieses Item schon sichtbar ist
        if (optionen->isItemChecked(2))
        {
            // wenn nein dann mach es sichtbar
            optionen->setItemEnabled(3,true);
        }
        else
        {
            //  wenn ja dann mach es wieder unsichtbar 
            optionen->setItemEnabled(3,false);
            optionen->setItemChecked(3,false);
            encodieren->setpart(false);
        }
    }

    // Senden der ausgewaehlten Werte
    if(auswahl==0)
    {
        encodieren->setboolunmount(optionen->isItemChecked(auswahl));
    }

    if(auswahl==1)
    {
        encodieren->setbooleject(optionen->isItemChecked(auswahl));
    }

    if(auswahl==2)
    {
        encodieren->setzusammenfuegen(optionen->isItemChecked(auswahl));
    }

    if(auswahl==3)
    {
        encodieren->setpart(optionen->isItemChecked(auswahl));
    }

    if(auswahl==4)
    {
        emit tvMode(optionen->isItemChecked(auswahl));
    }

}

void Menuebar::ruecksetzen (void)
{
    if(debuglevel>=2)
    {
        cout<<"Menubar.cpp   : * Slot : slot_ruecksetzten *"<<endl<<endl;
    }

    // Rueksetzen aller Einstellungen
    optionen->setItemChecked(0,false);
    optionen->setItemChecked(1,false);
    optionen->setItemEnabled(1,false);
    optionen->setItemChecked(2,false);
    optionen->setItemChecked(3,false);
    optionen->setItemEnabled(3,false);
    optionen->setItemChecked(4,false);
}

void Menuebar::slot_sprachen(int auswahl)
{
    if(debuglevel>=2)
    {
        cout<<"Menubar.cpp   : * Slot : slot_sprache *"<<endl<<endl;
    }

    if(auswahl==0)
    {
        emit deutsch();
    }

    if(auswahl==1)
    {
        emit english();
    }
}

void Menuebar::setDeutsch(void)
{
    if(debuglevel>=2)
    {
        cout<<"Menubar.cpp   : * Slot : setDetsch *"<<endl<<endl;
    }

    // Einstellung sichtbar machen
    sprache->setItemChecked(0,true);
    sprache->setItemChecked(1,false);
}

void Menuebar::setEnglish(void)
{
    if(debuglevel>=2)
    {
        cout<<"Menubar.cpp   : * Slot : setEnglish *"<<endl<<endl;
    }

    // Einstellung sichtbar machen
    sprache->setItemChecked(0,false);
    sprache->setItemChecked(1,true);
}


void Menuebar::slot_setFont(int schrift)
{
    // Aendern der Schriftgroesse in der Gesamten menuebar
    setFont(QFont("SansSerif",schrift));

    sprache       ->setFont(QFont("SansSerif",schrift));
    optionen      ->setFont(QFont("SansSerif",schrift));
    einstellungen ->setFont(QFont("SansSerif",schrift));
    datei         ->setFont(QFont("SansSerif",schrift));
}

void Menuebar::mountPfadDialog (void)
{
    if(debuglevel>=2)
    {
        cout<<"Menubar.cpp   : * Slot : mountPfadDialog  *"<<endl<<endl;
    }

    // Kontrollieren ob das 2 Laufwerk aktive ist
    set2Laufwerk(cblaufwerk->isChecked());

     // Die Sprache des Fensters einstellen
     mountpfad->setCaption(tr("Mountpfad Einstellungen"));

     //Texte der Ueberschriften fuer LineEdit erstellen
     zeile1->setText(tr("Mountpfad des Standard DVD-Laufwerk."));
     zeile2->setText(tr("Mountpfad fuer ein weiteres DVD-Laufwerk."));

     // Text fuer die Checkbox setzen
     cblaufwerk->setText(tr("Ist ein Zweites DVD-Laufwerk vorhanden?"));

     // Die alten mountpfade holen
     eingabe1->setText(encodieren->getmountpfad());
     eingabe2->setText(encodieren->getmountpfad2());

     // Text fuer den Uebernehmen Knopf
     ok->setText(tr("Ok"));

     // Text fuer den Uebernehmen Knopf
     abbrechen->setText(tr("Abbrechen"));

     // Fenster sichtbar machen
     mountpfad->show();
}

void Menuebar::set2Laufwerk (bool aktiv)
{
    if(aktiv==true)
    {
        // Die Farbe Anpassen 
        eingabe2->setPaletteForegroundColor(Qt::black);
        zeile2->setPaletteForegroundColor(Qt::black);

        // Eingaben wieder zulassen in der Eingabezeile 2
        eingabe2->setReadOnly(false);
    }
    else
    {
        // Die Farbe Anpassen 
        eingabe2->setPaletteForegroundColor(Qt::lightGray);
        zeile2  ->setPaletteForegroundColor(Qt::lightGray);

        // Keine Eingaben mehr zulassen in der Eingabezeile 2
        eingabe2->setReadOnly(true);
    }
}

void Menuebar::okgedreuckt (void)
{
    if(debuglevel>=2)
    {
        cout<<"Menubar.cpp   : * Slot : okgedreuckt  *"<<endl<<endl;
    }

    // Das Fenster ausblenden
    mountpfad->hide();

    // Den Wert aus der Eingabezeile1 holen 
    temp=eingabe1->text();

    // An encodierung melden das ein zweites DVD Laufwerk verwendet wird (speichern)
    encodieren->set2DVDLaufwerk(cblaufwerk->isChecked());

    // Die Ansicht auf dem Hauptfenster anpassen
    emit laufwerk(cblaufwerk->isChecked());

    // Den neuen Mountpfad bekannt machen
    encodieren->setmountpfad(temp);

    if(debuglevel>=3)
    {
        cout<<"Menubar.cpp   : Mountpfad DVD Laufwerk 1 : "<<temp<<endl<<endl;
    }

    if(cblaufwerk->isChecked()==true)
    {
        // Den Wert aus der Eingabezeile2 holen
        temp=eingabe2->text(); 

        // Den neuen Mountpfad bekannt machen
        encodieren->setmountpfad2(temp);

        if(debuglevel>=3)
        {
            cout<<"Menubar.cpp   : Mountpfad DVD Laufwerk 2 : "<<temp<<endl<<endl;
        }
    }
}

void Menuebar::abbrechengedreuckt (void)
{
    if(debuglevel>=2)
    {
        cout<<"Menubar.cpp   : * Slot : abbrechengedreuckt  *"<<endl<<endl;
    }

    // Das Fenster ausblenden
    mountpfad->hide();
}

# endif
