/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# ifndef MENUEBAR_H
# define MENUEBAR_H

# ifndef __STDC_LIMIT_MACROS
# define __STDC_LIMIT_MACROS
# endif

# include <qmenubar.h>
# include <qpopupmenu.h>
# include <qpixmap.h>
# include <qinputdialog.h>
# include <qstring.h>
# include <qdialog.h>
# include <qlabel.h>
# include <qlineedit.h>
# include <qcheckbox.h>
# include <qpushbutton.h>

# include "Encodieren.h"


class Menuebar : public QMenuBar
{
    Q_OBJECT
    private:
        QWidget *eltern;                         // Darin wird der Zeiger zum Elternwidget abgelegt

        QPopupMenu *datei,                       // Erstellt das Datei    Menue
                   *einstellungen,               // Erstellt das Einstellungs Menue
                   *optionen,                    // Erstellt das Shutdown Menue
                   *sprache;                     // Erstellt das Sprachen Menue

        QDialog    *mountpfad;                   // Zeigt ein Dialogfenster fuer den Maountpfad der DVD an

        QLabel     *zeile1,                      // Ueberschift fuer die erste  Zeile des Dialogs
                   *zeile2;                      // Ueberschift fuer die zweite Zeile des Dialogs

        QLineEdit  *eingabe1,                    // Eingabe Feld fuer das erste DVD Laufwerk
                   *eingabe2;                    // Eingabe Feld fuer das zweite DVD Laufwerk

        QCheckBox  *cblaufwerk;                  // Ob es ein zweites DVD Laufwerk giebt

        QPushButton *ok,                         // "OK" Knopf fuer den Mountpfad Dialog
                    *abbrechen;                  // "Abrrechen" Knopf fuer den Mountpfad Dialog

        Encodieren *encodieren;

        QString temp;                            // Temporaeren Stringobjekt fuer Mountpfad



        int debuglevel;

    public:
        Menuebar(QWidget *parent,Encodieren *uebergabe,int startdebug);

    private slots:
        void slot_datei        (int auswahl);
        void slot_einstellungen(int auswahl);
        void slot_sprachen     (int auswahl);
        void slot_optionen     (int auswahl);

    public slots:

        // Rueksetzen aller Einstellungen
        void ruecksetzen (void);

        // Die Sprache in der Menuebar auf Deutsch setzen
        void setDeutsch  (void);

        // Die Sprache in der Menuebar auf English setzen
        void setEnglish  (void);

        // Die Schriftgroesse in Menubar aendern
        void slot_setFont (int schrift);

        // Ein Dialogfenster fuer den Mauntpfadangabe
        void mountPfadDialog (void);

        // Das 2 Laufwerk aktiviren
        void set2Laufwerk (bool aktiv);

        // Wenn der "Ok" Knopf gedrueckt wurde dann schliesse das Fenster und gebe die Daten weiter
        void okgedreuckt (void);

        // Wenn der "Abbrechen" Knopf gedrueckt wurde dann schliesse das Fenster und verwerfe die Daten
        void abbrechengedreuckt (void);

    signals:
        void speichern      (void);
        void standard       (void);
        void exit           (void);
        void deutsch        (void);
        void english        (void);
        void tvMode         (bool);
        void laufwerk       (bool);
        void zweiteAudiospur(bool);
};

# endif
